﻿'Copyright (c) 2013-2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System

Public Class aosDisplayItemArray : Inherits System.Collections.CollectionBase

    Public Function AddNewStat(ByVal TabPage As System.Windows.Forms.TabPage, ByRef StatName As String, ByRef StatValue As String, ByVal StatID As Integer, ByVal id As Integer) As aosDisplayItem
        Dim aDspStat As New aosDisplayItem

        ' Add to the collection, and then add to the specified tab page
        Me.List.Add(aDspStat)
        TabPage.Controls.Add(aDspStat)
        aDspStat.ControlTabPage = TabPage
        ' Set default/initial properties for the object.
        aDspStat.Top = 2
        aDspStat.Left = 6
        aDspStat.Tag = Me.Count - 1
        aDspStat.StatName = StatName
        aDspStat.StatValue = StatValue
        aDspStat.StatID = StatID
        aDspStat.ItemID = id
        Return aDspStat
    End Function

    Public Function findById(ByRef id As Integer) As Integer
        Dim i As Integer

        For i = 0 To Me.List.Count - 1
            If CType(Me.List(i), aosDisplayItem).StatID = id Then
                Return i
            End If
        Next
        Return -1
    End Function

    Public Sub Remove()
        ' Check to be sure there is an object to remove.
        If Me.Count > 0 Then
            Me(Me.Count - 1).ControlTabPage.Controls.Remove(Me(Me.Count - 1))
            Me.List.RemoveAt(Me.Count - 1)
        End If
    End Sub

    Default Public ReadOnly Property Item(ByVal Index As Integer) As aosDisplayItem
        Get
            Return CType(Me.List.Item(Index), aosDisplayItem)
        End Get
    End Property

End Class
