﻿'Copyright (c) 2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Friend Class aosPerkCheckbox
    Inherits System.Windows.Forms.UserControl

    Private prvItemName As String = "Name"
    Private prvItemID As Integer = 9999
    Private prvTabPage As System.Windows.Forms.TabPage
    Private prvPerkListbox As ListBox
    Private prvPerkArray As PerkArray
    Private prvCheckboxArray As aosPerkCheckboxArray

#Region " Windows Form Designer generated code "

    Public Sub New(ByRef perk_listbox As ListBox, ByRef perk_array As PerkArray, ByRef checkbox_array As aosPerkCheckboxArray)
        MyBase.New()
        'This call is required by the Windows Form Designer.
        InitializeComponent()
        'Add any initialization after the InitializeComponent() call
        prvPerkListbox = perk_listbox
        prvPerkArray = perk_array
        prvCheckboxArray = checkbox_array
    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents chkControl As System.Windows.Forms.CheckBox
    Friend WithEvents aocbTooltip As System.Windows.Forms.ToolTip
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.chkControl = New System.Windows.Forms.CheckBox()
        Me.aocbTooltip = New System.Windows.Forms.ToolTip(Me.components)
        Me.SuspendLayout()
        '
        'chkControl
        '
        Me.chkControl.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkControl.Location = New System.Drawing.Point(0, 0)
        Me.chkControl.Name = "chkControl"
        Me.chkControl.Size = New System.Drawing.Size(336, 24)
        Me.chkControl.TabIndex = 0
        Me.chkControl.Text = "label"
        '
        'aosPerkCheckbox
        '
        Me.AutoSize = True
        Me.Controls.Add(Me.chkControl)
        Me.Name = "aosPerkCheckbox"
        Me.Size = New System.Drawing.Size(339, 27)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Property ItemName() As String
        Get
            Return prvItemName
        End Get
        Set(ByVal Value As String)
            prvItemName = Value
            Me.chkControl.Text = prvItemName
        End Set
    End Property

    Public Property ItemID() As Integer
        Get
            Return prvItemID
        End Get
        Set(ByVal Value As Integer)
            prvItemID = Value
            Me.aocbTooltip.AutoPopDelay = 6000
            Me.aocbTooltip.InitialDelay = 750
            Me.aocbTooltip.SetToolTip(Me.chkControl, ShowPerk(prvPerkArray, Value))
        End Set
    End Property

    Public Property ControlTabPage() As System.Windows.Forms.TabPage
        Get
            Return prvTabPage
        End Get
        Set(ByVal Value As System.Windows.Forms.TabPage)
            prvTabPage = Value
        End Set
    End Property

    Private Sub chkControl_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkControl.CheckedChanged
        Dim perk_id As Integer
        Dim perk_number As Integer
        Dim perks_required As Integer
        Dim num_checked As Integer
        Dim canPerk As Boolean = True

        If noRecalc = True Then
            Return
        End If
        ' get our id to look up perk array
        perk_id = Me.ItemID
        ' find which checkbox # we are
        perk_number = prvPerkArray(perk_id).Number - 1
        If Me.chkControl.Checked = True Then
            ' ensure that sufficient perk points are available (we need a way to handle LE perks as those are not restricted in the same way)
            perks_required = perk_number + 1
            ' factor out all perks already selected for this item
            num_checked = 0
            For i As Integer = 0 To perk_number - 1
                If prvCheckboxArray(i).chkControl.Checked = True Then
                    num_checked += 1
                End If
            Next
            perks_required -= num_checked
            ' handle SL and AI perks (fmMain.NudAlienTitleValue)
            ' LE perks aren't limited in this way
            If prvCheckboxArray.ID = "SL" Then
                If GetNumberOfSLPerks(fmMain.NudLevelValue) < (perks_required + prvPerkArray.NumSelectedPerks) Then
                    ' not enough points, deny change and warn user
                    Me.chkControl.Checked = False
                    canPerk = False
                    MsgBox("Insufficient Perk Points Available", MsgBoxStyle.OkOnly, "AOSkills")
                End If
            ElseIf prvCheckboxArray.ID = "AI" Then
                If fmMain.NudAlienTitleValue < (perks_required + prvPerkArray.NumSelectedPerks) Then
                    ' not enough points, deny change and warn user
                    Me.chkControl.Checked = False
                    canPerk = False
                    MsgBox("Insufficient Alien Perk Points Available", MsgBoxStyle.OkOnly, "AOSkills")
                End If
            ElseIf prvCheckboxArray.ID = "LE" Then
                ' probably nothing special to do in this case
            End If
            If canPerk Then
                noRecalc = True
                ' ensure all previous levels checked
                For i As Integer = 0 To perk_number
                    If prvCheckboxArray(i).chkControl.Checked = False Then
                        prvCheckboxArray(i).chkControl.Checked = True
                        If Not IsNothing(fmMain.LoggingHandle) Then
                            fmMain.LoggingHandle.LogPerk(prvCheckboxArray(i).Name, False, True)
                        End If
                        AddPerk(prvPerkArray, prvCheckboxArray(i).ItemID)
                    End If
                Next
                If Not IsNothing(fmMain.LoggingHandle) Then
                    fmMain.LoggingHandle.LogPerk(prvItemName, False, True)
                End If
                AddPerk(prvPerkArray, perk_id)
                noRecalc = False
            End If
        Else
            noRecalc = True
            ' ensure all later levels unchecked
            For i As Integer = perk_number + 1 To prvCheckboxArray.Count - 1
                If prvCheckboxArray(i).chkControl.Checked = True Then
                    prvCheckboxArray(i).chkControl.Checked = False
                    If Not IsNothing(fmMain.LoggingHandle) Then
                        fmMain.LoggingHandle.LogPerk(prvCheckboxArray(i).Name, True, False)
                    End If
                    RemPerk(prvPerkArray, prvCheckboxArray(i).ItemID)
                End If
            Next
            If Not IsNothing(fmMain.LoggingHandle) Then
                fmMain.LoggingHandle.LogPerk(prvItemName, True, False)
            End If
            RemPerk(prvPerkArray, perk_id)
            noRecalc = False
        End If
        If Not IsNothing(fmMain.LoggingHandle) Then
            fmMain.LoggingHandle.DisableLogging()
        End If
        ' recalc perks then all skills
        ConfigurePerks()
        UpdatePerkLabel(prvPerkListbox, prvPerkArray, prvPerkListbox.SelectedIndex)
        If Not IsNothing(fmMain.LoggingHandle) Then
            fmMain.LoggingHandle.EnableLogging()
        End If
        hasChanges = True

    End Sub

End Class
