﻿'Copyright (c) 2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Windows.Forms

Friend Class aosPerkCheckboxArray : Inherits System.Collections.CollectionBase

    Private prvID As String
    Private prvTabPage As TabPage

    Public Sub New(ByRef id As String, ByRef tp As TabPage)
        MyBase.New()
        prvID = id
        prvTabPage = tp
    End Sub

    Public Function AddNewCHK(ByVal tp As System.Windows.Forms.TabPage, ByRef nm As String, ByVal id As Integer, ByRef perk_listbox As ListBox, ByRef perk_array As PerkArray) As aosPerkCheckbox
        Dim aCHK As New aosPerkCheckbox(perk_listbox, perk_array, Me)

        ' Add to the collection, and then add to the specified tab page
        Me.List.Add(aCHK)
        tp.Controls.Add(aCHK)
        aCHK.ControlTabPage = tp
        ' Set default/initial properties for the object.
        aCHK.Top = 28
        aCHK.Left = 200
        aCHK.Width = 336
        aCHK.Height = 24
        aCHK.Tag = Me.Count - 1
        aCHK.ItemName = nm
        aCHK.ItemID = id
        Return aCHK
    End Function

    Public Sub Remove()
        ' Check to be sure there is an object to remove.
        If Me.Count > 0 Then
            Me(Me.Count - 1).ControlTabPage.Controls.Remove(Me(Me.Count - 1))
            Me.List.RemoveAt(Me.Count - 1)
        End If
    End Sub

    Default Public ReadOnly Property Item(ByVal Index As Integer) As aosPerkCheckbox
        Get
            Return CType(Me.List.Item(Index), aosPerkCheckbox)
        End Get
    End Property

    Public ReadOnly Property ID() As String
        Get
            Return prvID
        End Get
    End Property

    Public ReadOnly Property TabPage() As TabPage
        Get
            Return prvTabPage
        End Get
    End Property

End Class
