﻿'Copyright (c) 2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System

Public Class clsBuffListItem

    Private prv_Name As String
    Private prv_AOID As Integer

    Public Sub New(ByVal aoid As Integer, ByRef name As String)
        MyBase.New()
        prv_Name = name
        prv_AOID = aoid
    End Sub

    Public ReadOnly Property Name() As String
        Get
            Return prv_Name
        End Get
    End Property

    Public ReadOnly Property AOID() As Integer
        Get
            Return prv_AOID
        End Get
    End Property

    Public Overrides Function ToString() As String
        Return prv_Name
    End Function

    ' populates a modifiers array for the buff with this AOID
    Public Sub GetModifiers(ByRef tmpMods() As Integer)
        Dim lo_mods As String
        Dim hi_mods As String
        Dim QL As Integer = getQL(prv_AOID)

        If QL > 0 Then
            lo_mods = getStrModifiersByType(prv_AOID, MOD_BUFFS)
            hi_mods = getStrModifiersByType(prv_AOID, MOD_BUFFS)
            ' now parse lo_mods/hi_mods into tmpMods using ql to interpolate with
            ParseInterpolateAndAppend(prv_AOID, prv_AOID, lo_mods, hi_mods, CType(QL, Integer), tmpMods)
        End If
    End Sub

End Class
