'Copyright (c) 2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System

Public Class clsOrgBenefitListItem : Implements IEquatable(Of clsOrgBenefitListItem)

    Private prv_Label As String
    Private prv_QL As Integer

    Public Sub New(ByRef label As String)
        MyBase.New()
        prv_Label = label
        prv_QL = 0
    End Sub

    Public ReadOnly Property Label() As String
        Get
            Return prv_Label
        End Get
    End Property

    Public ReadOnly Property Name() As String
        Get
            Dim r As String
            If prv_Label.IndexOf(":", StringComparison.Ordinal) = 0 Then
                r = ""
            Else
                r = prv_Label.Substring(prv_Label.IndexOf(":", StringComparison.Ordinal) + 2)
            End If
            Return r
        End Get
    End Property

    Public Property QL() As Integer
        Get
            Return prv_QL
        End Get
        Set(ByVal Value As Integer)
            prv_QL = Value
        End Set
    End Property

    Public Overrides Function ToString() As String
        Return prv_Label
    End Function

    Public Overloads Function Equals(other As clsOrgBenefitListItem) As Boolean Implements IEquatable(Of AOSkills.clsOrgBenefitListItem).Equals
        Dim r As Boolean
        ' we want to compare on names only, so need to split the labels
        If Me.Name = other.Name Then
            r = True
        Else
            r = False
        End If
        Return r
    End Function

End Class
