'Copyright (c) 2005-2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Public Class frmBenefits : Inherits System.Windows.Forms.Form

    Friend org_list As clsOrgBenefitArray

    Private curQL As Decimal

    Private ShortName() As String = {"Small HQ", "Medium HQ", "Large HQ", "Grid House", "Landing Pad", "Swimming Pool", "Mining Operations"}
    Friend WithEvents flowBenefitsQL As System.Windows.Forms.FlowLayoutPanel
    Friend WithEvents flowBenefits As System.Windows.Forms.FlowLayoutPanel
    Friend WithEvents flowBenefitsControls As System.Windows.Forms.FlowLayoutPanel

    Private FullName() As String = {"Small Org HQ Management Benefit", "Medium Org HQ Management Benefit", "Large Org HQ Management Benefit", "Grid House Computer Literacy", "Landing Pad Vehicle Experience", "Swimming Pool Body Dev", "Mining Operations Nano Powerup"}

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()
        'This call is required by the Windows Form Designer.
        InitializeComponent()
        'Add any initialization after the InitializeComponent() call
        PopulateBenefitArray()
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents lstAvailable As System.Windows.Forms.ListBox
    Friend WithEvents lstSelected As System.Windows.Forms.ListBox
    Friend WithEvents cmdAdd As System.Windows.Forms.Button
    Friend WithEvents cmdRem As System.Windows.Forms.Button
    Friend WithEvents cmdClose As System.Windows.Forms.Button
    Friend WithEvents nudQL As System.Windows.Forms.NumericUpDown
    Friend WithEvents lstBonuses As System.Windows.Forms.ListBox
    Friend WithEvents cmdMin As System.Windows.Forms.Button
    Friend WithEvents cmdMax As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lstAvailable = New System.Windows.Forms.ListBox()
        Me.lstSelected = New System.Windows.Forms.ListBox()
        Me.cmdAdd = New System.Windows.Forms.Button()
        Me.cmdRem = New System.Windows.Forms.Button()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.cmdClose = New System.Windows.Forms.Button()
        Me.lstBonuses = New System.Windows.Forms.ListBox()
        Me.nudQL = New System.Windows.Forms.NumericUpDown()
        Me.cmdMin = New System.Windows.Forms.Button()
        Me.cmdMax = New System.Windows.Forms.Button()
        Me.flowBenefitsQL = New System.Windows.Forms.FlowLayoutPanel()
        Me.flowBenefits = New System.Windows.Forms.FlowLayoutPanel()
        Me.flowBenefitsControls = New System.Windows.Forms.FlowLayoutPanel()
        CType(Me.nudQL, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.flowBenefitsQL.SuspendLayout()
        Me.flowBenefits.SuspendLayout()
        Me.flowBenefitsControls.SuspendLayout()
        Me.SuspendLayout()
        '
        'lstAvailable
        '
        Me.lstAvailable.ItemHeight = 16
        Me.lstAvailable.Location = New System.Drawing.Point(4, 4)
        Me.lstAvailable.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.lstAvailable.Name = "lstAvailable"
        Me.lstAvailable.Size = New System.Drawing.Size(374, 324)
        Me.lstAvailable.Sorted = True
        Me.lstAvailable.TabIndex = 0
        '
        'lstSelected
        '
        Me.lstSelected.ItemHeight = 16
        Me.lstSelected.Location = New System.Drawing.Point(620, 4)
        Me.lstSelected.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.lstSelected.Name = "lstSelected"
        Me.lstSelected.Size = New System.Drawing.Size(374, 324)
        Me.lstSelected.Sorted = True
        Me.lstSelected.TabIndex = 1
        '
        'cmdAdd
        '
        Me.cmdAdd.Location = New System.Drawing.Point(4, 4)
        Me.cmdAdd.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.cmdAdd.Name = "cmdAdd"
        Me.cmdAdd.Size = New System.Drawing.Size(218, 40)
        Me.cmdAdd.TabIndex = 2
        Me.cmdAdd.Text = "Add >>"
        '
        'cmdRem
        '
        Me.cmdRem.Location = New System.Drawing.Point(4, 238)
        Me.cmdRem.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.cmdRem.Name = "cmdRem"
        Me.cmdRem.Size = New System.Drawing.Size(218, 40)
        Me.cmdRem.TabIndex = 3
        Me.cmdRem.Text = "<< Remove"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(4, 0)
        Me.Label1.Margin = New System.Windows.Forms.Padding(4, 0, 4, 0)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(80, 29)
        Me.Label1.TabIndex = 5
        Me.Label1.Text = "Benefit QL:"
        '
        'cmdClose
        '
        Me.cmdClose.Anchor = System.Windows.Forms.AnchorStyles.None
        Me.cmdClose.Location = New System.Drawing.Point(391, 356)
        Me.cmdClose.Margin = New System.Windows.Forms.Padding(4, 8, 4, 4)
        Me.cmdClose.Name = "cmdClose"
        Me.cmdClose.Size = New System.Drawing.Size(218, 40)
        Me.cmdClose.TabIndex = 7
        Me.cmdClose.Text = "Close"
        '
        'lstBonuses
        '
        Me.lstBonuses.ItemHeight = 16
        Me.lstBonuses.Location = New System.Drawing.Point(4, 98)
        Me.lstBonuses.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.lstBonuses.Name = "lstBonuses"
        Me.lstBonuses.Size = New System.Drawing.Size(216, 132)
        Me.lstBonuses.TabIndex = 8
        '
        'nudQL
        '
        Me.nudQL.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudQL.Location = New System.Drawing.Point(120, 4)
        Me.nudQL.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.nudQL.Maximum = New Decimal(New Integer() {300, 0, 0, 0})
        Me.nudQL.Minimum = New Decimal(New Integer() {1, 0, 0, 0})
        Me.nudQL.Name = "nudQL"
        Me.nudQL.Size = New System.Drawing.Size(61, 29)
        Me.nudQL.TabIndex = 9
        Me.nudQL.Value = New Decimal(New Integer() {1, 0, 0, 0})
        '
        'cmdMin
        '
        Me.cmdMin.Font = New System.Drawing.Font("Marlett", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(2, Byte))
        Me.cmdMin.Location = New System.Drawing.Point(92, 4)
        Me.cmdMin.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.cmdMin.Name = "cmdMin"
        Me.cmdMin.Size = New System.Drawing.Size(20, 30)
        Me.cmdMin.TabIndex = 10
        Me.cmdMin.Text = "u"
        '
        'cmdMax
        '
        Me.cmdMax.Font = New System.Drawing.Font("Marlett", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(2, Byte))
        Me.cmdMax.Location = New System.Drawing.Point(189, 4)
        Me.cmdMax.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.cmdMax.Name = "cmdMax"
        Me.cmdMax.Size = New System.Drawing.Size(20, 30)
        Me.cmdMax.TabIndex = 11
        Me.cmdMax.Text = "t"
        '
        'flowBenefitsQL
        '
        Me.flowBenefitsQL.AutoSize = True
        Me.flowBenefitsQL.Controls.Add(Me.Label1)
        Me.flowBenefitsQL.Controls.Add(Me.cmdMin)
        Me.flowBenefitsQL.Controls.Add(Me.nudQL)
        Me.flowBenefitsQL.Controls.Add(Me.cmdMax)
        Me.flowBenefitsQL.Location = New System.Drawing.Point(4, 52)
        Me.flowBenefitsQL.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.flowBenefitsQL.Name = "flowBenefitsQL"
        Me.flowBenefitsQL.Size = New System.Drawing.Size(213, 38)
        Me.flowBenefitsQL.TabIndex = 13
        '
        'flowBenefits
        '
        Me.flowBenefits.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.flowBenefits.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink
        Me.flowBenefits.Controls.Add(Me.lstAvailable)
        Me.flowBenefits.Controls.Add(Me.flowBenefitsControls)
        Me.flowBenefits.Controls.Add(Me.lstSelected)
        Me.flowBenefits.Location = New System.Drawing.Point(5, 4)
        Me.flowBenefits.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.flowBenefits.Name = "flowBenefits"
        Me.flowBenefits.Size = New System.Drawing.Size(1005, 340)
        Me.flowBenefits.TabIndex = 3
        '
        'flowBenefitsControls
        '
        Me.flowBenefitsControls.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.flowBenefitsControls.AutoSize = True
        Me.flowBenefitsControls.Controls.Add(Me.cmdAdd)
        Me.flowBenefitsControls.Controls.Add(Me.flowBenefitsQL)
        Me.flowBenefitsControls.Controls.Add(Me.lstBonuses)
        Me.flowBenefitsControls.Controls.Add(Me.cmdRem)
        Me.flowBenefitsControls.FlowDirection = System.Windows.Forms.FlowDirection.TopDown
        Me.flowBenefitsControls.Location = New System.Drawing.Point(386, 4)
        Me.flowBenefitsControls.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.flowBenefitsControls.Name = "flowBenefitsControls"
        Me.flowBenefitsControls.Size = New System.Drawing.Size(226, 282)
        Me.flowBenefitsControls.TabIndex = 1
        '
        'frmBenefits
        '
        Me.AutoScaleDimensions = New System.Drawing.SizeF(120.0!, 120.0!)
        Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Dpi
        Me.ClientSize = New System.Drawing.Size(1028, 422)
        Me.ControlBox = False
        Me.Controls.Add(Me.flowBenefits)
        Me.Controls.Add(Me.cmdClose)
        Me.Margin = New System.Windows.Forms.Padding(4, 4, 4, 4)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.MinimumSize = New System.Drawing.Size(1040, 434)
        Me.Name = "frmBenefits"
        Me.Text = "Manage Org Benefits"
        CType(Me.nudQL, System.ComponentModel.ISupportInitialize).EndInit()
        Me.flowBenefitsQL.ResumeLayout(False)
        Me.flowBenefits.ResumeLayout(False)
        Me.flowBenefits.PerformLayout()
        Me.flowBenefitsControls.ResumeLayout(False)
        Me.flowBenefitsControls.PerformLayout()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Sub UpdateMisc()
        Dim i As Integer

        noRecalc = True
        For i = 0 To NUM_ATTRS - 1
            attrCA.Item(i).Misc = 0
        Next
        For i = 0 To NUM_SKILLS - 1
            skillsCA.Item(i).Misc = 0
        Next
        hpCA.Misc = 0
        npCA.Misc = 0
        ProcessAllBenefits()
        noRecalc = False
        recalcIP()
    End Sub

    Private Sub SetOrgBenefitBonuses(ByVal ob As clsOrgBenefitListItem)
        Dim tmpMods(NUM_SKILLS + NUM_ATTRS + NUM_OTHER_STATS + 1) As Integer
        Dim name As String
        Dim lo_ql As Integer
        Dim hi_ql As Integer
        Dim lo_aoid As Integer
        Dim hi_aoid As Integer
        Dim aosid As Integer

        ' init tmpMods array to -1 so we can see and display 0s!
        ' this works ok as we are only calling for 1 "item" and not actually summing mods
        For i As Integer = 0 To tmpMods.Length - 1
            tmpMods(i) = -1
        Next
        ' calculate benefits form char level and selected ql
        ' need to find AOIDs that bracket this QL
        prv_FindAOIDs(ob, lo_ql, hi_ql, lo_aoid, hi_aoid)
        getOrgBenefitModifiers(lo_aoid, hi_aoid, CInt(Me.nudQL.Value), tmpMods)
        Me.lstBonuses.Items.Clear()
        For i As Integer = 0 To tmpMods.Length - 1
            If tmpMods(i) <> -1 Then
                ' process modifiers into buff element of controls and handle other stats
                If i >= 0 And i <= 68 Then
                    ' skills
                    aosid = i
                ElseIf i >= 69 And i <= 74 Then
                    ' attributes
                    aosid = i + 200 - 69
                ElseIf i = 75 Then
                    ' hps
                    aosid = 100
                ElseIf i = 76 Then
                    ' nps
                    aosid = 101
                Else
                    ' other stats
                    aosid = i + 400 - 77
                End If
                name = objSkillDict.Find_AOSName_From_AOSID(aosid)
                ' add 1 on as in this case we started at -1!
                Me.lstBonuses.Items.Add(name & " : " & CStr(tmpMods(i) + 1))
            End If
        Next
    End Sub

    Private Sub lstAvailable_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstAvailable.SelectedIndexChanged
        Dim ob As clsOrgBenefitListItem
        Dim loql As Integer = 301
        Dim hiql As Integer = 0

        If Me.lstAvailable.SelectedIndex = -1 Then
            Return
        End If
        ' parse benefits from OrgBenefits1 that match the name selected
        ob = CType(Me.lstAvailable.Items(Me.lstAvailable.SelectedIndex), clsOrgBenefitListItem)
        For Each bo As clsOrgBenefit In org_list
            If bo.Name = ob.Name Then
                loql = bo.MinQL
                hiql = bo.MaxQL
                Exit For
            End If
        Next
        Me.nudQL.Minimum = loql
        Me.nudQL.Maximum = hiql
        Me.nudQL.Value = loql
        SetOrgBenefitBonuses(ob)
    End Sub

    Private Sub lstSelected_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstSelected.SelectedIndexChanged
        Dim ob As clsOrgBenefitListItem
        Dim loql As Integer = 301
        Dim hiql As Integer = 0

        If Me.lstSelected.SelectedIndex = -1 Then
            Return
        End If
        ' parse benefits from OrgBenefits1 that match the name selected
        ob = CType(Me.lstSelected.Items(Me.lstSelected.SelectedIndex), clsOrgBenefitListItem)
        For Each bo As clsOrgBenefit In org_list
            If bo.Name = ob.Name Then
                loql = bo.MinQL
                hiql = bo.MaxQL
                Exit For
            End If
        Next
        Me.nudQL.Minimum = loql
        Me.nudQL.Maximum = hiql
        Me.nudQL.Value = ob.QL
        SetOrgBenefitBonuses(ob)
    End Sub

    Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
        UpdateMisc()
        Me.Hide()
    End Sub

    Private Sub nudQL_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudQL.ValueChanged
        If Me.lstAvailable.SelectedIndex <> -1 Then
            SetOrgBenefitBonuses(CType(Me.lstAvailable.Items(Me.lstAvailable.SelectedIndex), clsOrgBenefitListItem))
        End If
    End Sub

    Private Sub nudQL_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles nudQL.Enter
        curQL = Me.nudQL.Value
    End Sub

    Private Sub nudQL_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles nudQL.Leave
        If Me.nudQL.Value <> curQL Then
            If Me.lstAvailable.SelectedIndex <> -1 Then
                SetOrgBenefitBonuses(CType(Me.lstAvailable.Items(Me.lstAvailable.SelectedIndex), clsOrgBenefitListItem))
            End If
        End If
    End Sub

    Private Sub cmdAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAdd.Click
        Dim ob As clsOrgBenefitListItem

        If Me.lstAvailable.SelectedIndex <> -1 Then
            ob = CType(Me.lstAvailable.Items(Me.lstAvailable.SelectedIndex), clsOrgBenefitListItem)
            Me.lstAvailable.Items.Remove(ob)
            ob.QL = CInt(Me.nudQL.Value)
            Me.lstSelected.Items.Add(ob)
            UpdateMisc()
            hasChanges = True
        End If
    End Sub

    Private Sub cmdRem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRem.Click
        Dim ob As clsOrgBenefitListItem

        If Me.lstSelected.SelectedIndex <> -1 Then
            ob = CType(Me.lstSelected.Items(Me.lstSelected.SelectedIndex), clsOrgBenefitListItem)
            Me.lstSelected.Items.Remove(ob)
            ob.QL = 0
            Me.lstAvailable.Items.Add(ob)
            UpdateMisc()
            hasChanges = True
        End If
    End Sub

    Private Sub cmdMin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdMin.Click
        Me.nudQL.Value = Me.nudQL.Minimum
    End Sub

    Private Sub cmdMax_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdMax.Click
        Me.nudQL.Value = Me.nudQL.Maximum
    End Sub

    Public Sub PopulateBenefitArray()
        Dim db_data As SQLite.SQLiteDataReader
        Dim aoid As Integer
        Dim name As String
        Dim ql As Integer
        Dim type As String
        Dim min_ql As Integer
        Dim max_ql As Integer
        Dim org As clsOrgBenefit

        Me.lstAvailable.Items.Clear()
        Me.lstSelected.Items.Clear()
        org_list = New clsOrgBenefitArray
        db_data = getBenefitList()
        Do While db_data.Read()
            aoid = CInt(db_data("aoid").ToString())
            name = db_data("name").ToString()
            ql = CInt(db_data("ql").ToString())
            type = db_data("type").ToString()
            org = org_list.AddNew(aoid, name, ql, type)
        Loop
        db_data = getBenefitListQLs()
        Do While db_data.Read()
            name = db_data("name").ToString()
            min_ql = CInt(db_data("min_ql").ToString())
            max_ql = CInt(db_data("max_ql").ToString())
            type = db_data("type").ToString()
            For Each ob As clsOrgBenefit In org_list
                If ob.Name = name And ob.Type = type Then
                    ob.MinQL = min_ql
                    ob.MaxQL = max_ql
                End If
            Next
            lstAvailable.Items.Add(New clsOrgBenefitListItem(type & ": " & name))
        Loop
    End Sub

    ' used by modXML.loadDataNew()
    Public Sub SetBenefits(ByRef BenefitStringArray As Collections.ArrayList)
        ' process benefits collection and ensure items in appropriate list
        ' start by resetting lists
        ClearAllocatedBenefits()
        ' parse round whatever array we've loaded benefit details into and call ProcessBenefit on each entry
        For Each b As String In BenefitStringArray
            ProcessBenefit(CStr(b))
        Next
        UpdateMisc()
    End Sub

    ' Mining Operations Nano Powerup @ QL234
    ' Mining Operations @ QL234
    Private Sub ProcessBenefit(ByRef benefits As String)
        Dim name As String
        Dim label As String
        Dim ql As Integer
        Dim pos As Integer
        Dim obt As clsOrgBenefitListItem
        Dim obl As clsOrgBenefitListItem

        name = benefits.Substring(0, benefits.IndexOf("@", StringComparison.Ordinal) - 1)
        ql = CInt(benefits.Substring(benefits.IndexOf("@ QL", StringComparison.Ordinal) + 4))
        ' we'll need to map certain names as CP can output the short names
        For i As Integer = 0 To ShortName.Length - 1
            If name = ShortName(i) Then
                name = FullName(i)
                Exit For
            End If
        Next
        ' find name in lstAvailable and move it to lstSelected, setting the QL
        obt = New clsOrgBenefitListItem("DUMMY: " & name)
        pos = -1
        For i As Integer = 0 To fmBene.lstAvailable.Items.Count - 1
            If obt.Equals(CType(fmBene.lstAvailable.Items(i), clsOrgBenefitListItem)) Then
                pos = i
                Exit For
            End If
        Next
        If pos <> -1 Then
            ' get details, then remove from lstAvailable and add to lstSelected
            label = CType(Me.lstAvailable.Items(pos), clsOrgBenefitListItem).Label
            Me.lstAvailable.Items.Remove(pos)
            obl = New clsOrgBenefitListItem(label)
            obl.QL = ql
            lstSelected.Items.Add(obl)
        End If
    End Sub

    Public Sub ClearAllocatedBenefits()
        Dim nobl As clsOrgBenefitListItem
        ' process lstSelected and copy everything into lstAvailable with QL of 0
        For Each obl As clsOrgBenefitListItem In lstSelected.Items
            nobl = New clsOrgBenefitListItem(obl.Label)
            nobl.QL = 0
            lstAvailable.Items.Add(nobl)
        Next
        ' then clear lstSelected
        lstSelected.Items.Clear()
    End Sub

    Private Sub prv_FindAOIDs(ByRef ob As clsOrgBenefitListItem, ByRef lo_ql As Integer, ByRef hi_ql As Integer, ByRef lo_aoid As Integer, ByRef hi_aoid As Integer)
        lo_aoid = -1
        hi_aoid = -1
        lo_ql = 999
        hi_ql = 0
        For Each x As clsOrgBenefit In org_list
            If x.Name = ob.Name Then
                If x.QL < lo_ql Then
                    lo_ql = x.QL
                    lo_aoid = x.AOID
                End If
                If x.QL > hi_ql Then
                    hi_ql = x.QL
                    hi_aoid = x.AOID
                End If
            End If
        Next
    End Sub

    Public Sub Reset()
        Dim i As Integer
        Dim old_noRecalc As Boolean

        old_noRecalc = noRecalc
        noRecalc = True
        For i = 0 To NUM_ATTRS - 1
            attrCA.Item(i).Misc = 0
        Next
        For i = 0 To NUM_SKILLS - 1
            skillsCA.Item(i).Misc = 0
        Next
        hpCA.Misc = 0
        npCA.Misc = 0
        ClearAllocatedBenefits()
        noRecalc = old_noRecalc
        recalcIP()
    End Sub

    Public Sub ProcessAllBenefits()
        Dim lo_aoid As Integer
        Dim hi_aoid As Integer
        Dim lo_ql As Integer
        Dim hi_ql As Integer
        Dim tmpMods(NUM_SKILLS + NUM_ATTRS + NUM_OTHER_STATS + 1) As Integer

        'Me.Reset()
        For Each ob As clsOrgBenefitListItem In Me.lstSelected.Items
            ' we have a name and ql, so we need to find the lo and hi aoids that match in org_list
            prv_FindAOIDs(ob, lo_ql, hi_ql, lo_aoid, hi_aoid)
            If lo_aoid <> -1 And hi_aoid <> -1 Then
                getOrgBenefitModifiers(lo_aoid, hi_aoid, ob.QL, tmpMods)
            End If
        Next
        prv_AdjustOrgBenefits(tmpMods, +1)
    End Sub

    Public Sub getOrgBenefitModifiers(ByVal lo_aoid As Integer, ByVal hi_aoid As Integer, ByVal ql As Integer, ByRef tmpMods() As Integer)
        Dim lo_mods As String
        Dim hi_mods As String

        lo_mods = getStrModifiersByType(lo_aoid, MOD_BENEFITS)
        hi_mods = getStrModifiersByType(hi_aoid, MOD_BENEFITS)
        ' now parse lo_mods/hi_mods into tmpMods using ql to interpolate with
        ParseInterpolateAndAppend(lo_aoid, hi_aoid, lo_mods, hi_mods, CType(ql, Integer), tmpMods)
    End Sub

    Private Sub prv_AdjustOrgBenefits(ByRef tmpMods() As Integer, ByVal adjust As Integer)
        For i As Integer = 0 To tmpMods.Length - 1
            If tmpMods(i) <> 0 Then
                ' process modifiers into buff element of controls and handle other stats
                If i >= 0 And i <= 68 Then
                    ' skills
                    skillsCA(i).Misc = skillsCA(i).Misc + (tmpMods(i) * adjust)
                ElseIf i >= 69 And i <= 74 Then
                    ' attributes
                    attrCA(i - 69).Misc = attrCA(i - 69).Misc + (tmpMods(i) * adjust)
                ElseIf i = 75 Then
                    ' hps
                    hpCA.Misc = hpCA.Misc + (tmpMods(i) * adjust)
                ElseIf i = 76 Then
                    ' nps
                    npCA.Misc = npCA.Misc + (tmpMods(i) * adjust)
                Else
                    ' other stats
                    statDSP(i - 77).StatValue = CStr(CInt(statDSP(i - 77).StatValue) + (tmpMods(i) * adjust))
                End If
            End If
        Next
    End Sub

    Private Sub frmBenefits_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Me.Top = form_positions(FORM_ORG, FORM_TOP)
        Me.Left = form_positions(FORM_ORG, FORM_LEFT)
        Me.Width = form_positions(FORM_ORG, FORM_WIDTH)
        Me.Height = form_positions(FORM_ORG, FORM_HEIGHT)
        fmBeneShown = True
    End Sub

    Private Sub frmBenefits_Resize(sender As Object, e As System.EventArgs) Handles Me.Resize
        Dim dpiX As Double = (Me.CreateGraphics().DpiX / 96)
        Dim cw As Integer = flowBenefitsQL.Width
        Dim ww As Integer = CInt(flowBenefits.Width - flowBenefitsControls.Width)

        flowBenefits.Left = CInt((Me.ClientSize.Width / 2) - (flowBenefits.Width / 2))
        cmdAdd.Width = cw
        cmdRem.Width = cw
        lstBonuses.Width = cw
        lstAvailable.Height = CInt(flowBenefits.Height - (dpiX * 3))
        lstSelected.Height = CInt(flowBenefits.Height - (dpiX * 3))
        lstAvailable.Width = CInt((ww / 2) - (flowBenefits.Margin.Left + flowBenefits.Margin.Right + flowBenefitsControls.Margin.Left + flowBenefitsControls.Margin.Right))
        lstSelected.Width = CInt((ww / 2) - (flowBenefits.Margin.Left + flowBenefits.Margin.Right + flowBenefitsControls.Margin.Left + flowBenefitsControls.Margin.Right))
        cmdClose.Left = CInt((Me.ClientSize.Width / 2) - (cmdClose.Width / 2))
        cmdClose.Top = CInt(Me.ClientSize.Height - cmdClose.Height - (dpiX * 12))
    End Sub

End Class
