'Copyright (c) 2003-2014 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills4.
'
'AOSkills4 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills4 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills4. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.IO
Imports System.Data
Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Public Class frmMain : Inherits System.Windows.Forms.Form

    Public LoggingHandle As ActionLogger

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()
        'This call is required by the Windows Form Designer.
        InitializeComponent()
        'Add any initialization after the InitializeComponent() call
        SetPaths()
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents miFile As System.Windows.Forms.MenuItem
    Friend WithEvents tabControls As System.Windows.Forms.TabControl
    Friend WithEvents tabAttr As System.Windows.Forms.TabPage
    Friend WithEvents tabSkills1 As System.Windows.Forms.TabPage
    Friend WithEvents tabSkills2 As System.Windows.Forms.TabPage
    Friend WithEvents tabSkills3 As System.Windows.Forms.TabPage
    Friend WithEvents tabSkills5 As System.Windows.Forms.TabPage
    Friend WithEvents tabSkills6 As System.Windows.Forms.TabPage
    Friend WithEvents tabSkills7 As System.Windows.Forms.TabPage
    Friend WithEvents tabSkills8 As System.Windows.Forms.TabPage
    Friend WithEvents tabSkills9 As System.Windows.Forms.TabPage
    Friend WithEvents lblAbilitiesEquip As System.Windows.Forms.Label
    Friend WithEvents lblAbilitiesBuff As System.Windows.Forms.Label
    Friend WithEvents lblAbilitiesImp As System.Windows.Forms.Label
    Friend WithEvents lblAbilitiesIP As System.Windows.Forms.Label
    Friend WithEvents tabSkills4 As System.Windows.Forms.TabPage
    Friend WithEvents lblBodyIP As System.Windows.Forms.Label
    Friend WithEvents lblBodyImp As System.Windows.Forms.Label
    Friend WithEvents lblBodyBuff As System.Windows.Forms.Label
    Friend WithEvents lblBodyEquip As System.Windows.Forms.Label
    Friend WithEvents lblMeleeIP As System.Windows.Forms.Label
    Friend WithEvents lblMeleeImp As System.Windows.Forms.Label
    Friend WithEvents lblMeleeBuff As System.Windows.Forms.Label
    Friend WithEvents lblMeleeEquip As System.Windows.Forms.Label
    Friend WithEvents lblMeleeSpecIP As System.Windows.Forms.Label
    Friend WithEvents lblMeleeSpecImp As System.Windows.Forms.Label
    Friend WithEvents lblMeleeSpecBuff As System.Windows.Forms.Label
    Friend WithEvents lblMeleeSpecEquip As System.Windows.Forms.Label
    Friend WithEvents lblRangedIP As System.Windows.Forms.Label
    Friend WithEvents lblRangedImp As System.Windows.Forms.Label
    Friend WithEvents lblRangedBuff As System.Windows.Forms.Label
    Friend WithEvents lblRangedEquip As System.Windows.Forms.Label
    Friend WithEvents lblRangeSpecIP As System.Windows.Forms.Label
    Friend WithEvents lblRangeSpecImp As System.Windows.Forms.Label
    Friend WithEvents lblRangeSpecEquip As System.Windows.Forms.Label
    Friend WithEvents lblNanoIP As System.Windows.Forms.Label
    Friend WithEvents lblNanoImp As System.Windows.Forms.Label
    Friend WithEvents lblNanoBuff As System.Windows.Forms.Label
    Friend WithEvents lblNanoEquip As System.Windows.Forms.Label
    Friend WithEvents lblExploreIP As System.Windows.Forms.Label
    Friend WithEvents lblExploreImp As System.Windows.Forms.Label
    Friend WithEvents lblExploreBuff As System.Windows.Forms.Label
    Friend WithEvents lblExploreEquip As System.Windows.Forms.Label
    Friend WithEvents lblTradeIP As System.Windows.Forms.Label
    Friend WithEvents lblTradeImp As System.Windows.Forms.Label
    Friend WithEvents lblTradeBuff As System.Windows.Forms.Label
    Friend WithEvents lblTradeEquip As System.Windows.Forms.Label
    Friend WithEvents lblCombatIP As System.Windows.Forms.Label
    Friend WithEvents lblCombatImp As System.Windows.Forms.Label
    Friend WithEvents lblCombatBuff As System.Windows.Forms.Label
    Friend WithEvents lblCombatEquip As System.Windows.Forms.Label
    Friend WithEvents miEdit As System.Windows.Forms.MenuItem
    Friend WithEvents meOpen As System.Windows.Forms.MenuItem
    Friend WithEvents meSave As System.Windows.Forms.MenuItem
    Friend WithEvents meSaveAs As System.Windows.Forms.MenuItem
    Friend WithEvents mePrint As System.Windows.Forms.MenuItem
    Friend WithEvents meExit As System.Windows.Forms.MenuItem
    Friend WithEvents meReset As System.Windows.Forms.MenuItem
    Friend WithEvents meMaxAttr As System.Windows.Forms.MenuItem
    Friend WithEvents meClearBuff As System.Windows.Forms.MenuItem
    Friend WithEvents miHelp As System.Windows.Forms.MenuItem
    Friend WithEvents meAbout As System.Windows.Forms.MenuItem
    Friend WithEvents lblAbilitiesPerk As System.Windows.Forms.Label
    Friend WithEvents lblBodyPerk As System.Windows.Forms.Label
    Friend WithEvents lblMeleePerk As System.Windows.Forms.Label
    Friend WithEvents lblMeleeSpecPerk As System.Windows.Forms.Label
    Friend WithEvents lblRangedPerk As System.Windows.Forms.Label
    Friend WithEvents lblRangeSpecPerk As System.Windows.Forms.Label
    Friend WithEvents lblNanoPerk As System.Windows.Forms.Label
    Friend WithEvents lblExplorePerk As System.Windows.Forms.Label
    Friend WithEvents lblTradePerk As System.Windows.Forms.Label
    Friend WithEvents lblCombatPerk As System.Windows.Forms.Label
    Friend WithEvents fdOpen As System.Windows.Forms.OpenFileDialog
    Friend WithEvents fdSave As System.Windows.Forms.SaveFileDialog
    Friend WithEvents meClearPerks As System.Windows.Forms.MenuItem
    Friend WithEvents sePrintDocument As System.Drawing.Printing.PrintDocument
    Friend WithEvents mePrintPreview As System.Windows.Forms.MenuItem
    Friend WithEvents meLoadPerks As System.Windows.Forms.MenuItem
    Friend WithEvents fdSaveBuff As System.Windows.Forms.SaveFileDialog
    Friend WithEvents fdOpenImp As System.Windows.Forms.OpenFileDialog
    Friend WithEvents fdSaveImp As System.Windows.Forms.SaveFileDialog
    Friend WithEvents fdOpenEqu As System.Windows.Forms.OpenFileDialog
    Friend WithEvents fdSaveEqu As System.Windows.Forms.SaveFileDialog
    Friend WithEvents fdOpenPerk As System.Windows.Forms.OpenFileDialog
    Friend WithEvents fdSavePerk As System.Windows.Forms.SaveFileDialog
    Friend WithEvents miBuffs As System.Windows.Forms.MenuItem
    Friend WithEvents miEquipment As System.Windows.Forms.MenuItem
    Friend WithEvents miPerks As System.Windows.Forms.MenuItem
    Friend WithEvents lblAbilitiesOrg As System.Windows.Forms.Label
    Friend WithEvents lblBodyOrg As System.Windows.Forms.Label
    Friend WithEvents lblMeleeOrg As System.Windows.Forms.Label
    Friend WithEvents lblMeleeSpecOrg As System.Windows.Forms.Label
    Friend WithEvents lblRangedOrg As System.Windows.Forms.Label
    Friend WithEvents lblRangeSpecOrg As System.Windows.Forms.Label
    Friend WithEvents lblNanoOrg As System.Windows.Forms.Label
    Friend WithEvents lblExploreOrg As System.Windows.Forms.Label
    Friend WithEvents lblCombatOrg As System.Windows.Forms.Label
    Friend WithEvents lblTradeOrg As System.Windows.Forms.Label
    Friend WithEvents meSavePerks As System.Windows.Forms.MenuItem
    Friend WithEvents tabPerks As System.Windows.Forms.TabPage
    Friend WithEvents lblPerkList As System.Windows.Forms.Label
    Friend WithEvents lstPerks As System.Windows.Forms.ListBox
    Friend WithEvents lblPerkPoints As System.Windows.Forms.Label
    Friend WithEvents miOrgs As System.Windows.Forms.MenuItem
    Friend WithEvents meClearMisc As System.Windows.Forms.MenuItem
    Friend WithEvents meLoadMisc As System.Windows.Forms.MenuItem
    Friend WithEvents meSaveMisc As System.Windows.Forms.MenuItem
    Friend WithEvents fdOpenMisc As System.Windows.Forms.OpenFileDialog
    Friend WithEvents fdSaveMisc As System.Windows.Forms.SaveFileDialog
    Friend WithEvents tabAIPerks As System.Windows.Forms.TabPage
    Friend WithEvents Label67 As System.Windows.Forms.Label
    Friend WithEvents nudAlienTitle As System.Windows.Forms.NumericUpDown
    Friend WithEvents lstAIPerks As System.Windows.Forms.ListBox
    Friend WithEvents lblAIPerks As System.Windows.Forms.Label
    Friend WithEvents meEquipConfig As System.Windows.Forms.MenuItem
    Friend WithEvents meManageBuffs As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem10 As System.Windows.Forms.MenuItem
    Friend WithEvents sbInfo As System.Windows.Forms.StatusBar
    Friend WithEvents MenuItem13 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem14 As System.Windows.Forms.MenuItem
    Friend WithEvents meManageMisc As System.Windows.Forms.MenuItem
    Friend WithEvents tabResearch As System.Windows.Forms.TabPage
    Friend WithEvents lstResearch As System.Windows.Forms.ListBox
    Friend WithEvents fdOpenRawData As System.Windows.Forms.OpenFileDialog
    Friend WithEvents meOpenRawData As System.Windows.Forms.MenuItem
    Friend WithEvents miLogging As System.Windows.Forms.MenuItem
    Friend WithEvents meLoggingToggle As System.Windows.Forms.MenuItem
    Friend WithEvents lblRangeSpecBuff As System.Windows.Forms.Label
    Friend WithEvents tabOthers As System.Windows.Forms.TabPage
    Friend WithEvents tabSkills10 As System.Windows.Forms.TabPage
    Friend WithEvents lblLegacyOrg As System.Windows.Forms.Label
    Friend WithEvents lblLegacyPerk As System.Windows.Forms.Label
    Friend WithEvents lblLegacyIP As System.Windows.Forms.Label
    Friend WithEvents lblLegacyImp As System.Windows.Forms.Label
    Friend WithEvents lblLegacyBuff As System.Windows.Forms.Label
    Friend WithEvents lblLegacyEquip As System.Windows.Forms.Label
    Friend WithEvents meResetIH As System.Windows.Forms.MenuItem
    Friend WithEvents meResetBC As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents FlowLayoutPanel1 As System.Windows.Forms.FlowLayoutPanel
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents nudLevel As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents cmbProf As System.Windows.Forms.ComboBox
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents cmbBreed As System.Windows.Forms.ComboBox
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents lblIP As System.Windows.Forms.Label
    Friend WithEvents meImplantConfig As System.Windows.Forms.MenuItem

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmMain))
        Me.tabControls = New System.Windows.Forms.TabControl()
        Me.tabAttr = New System.Windows.Forms.TabPage()
        Me.lblAbilitiesOrg = New System.Windows.Forms.Label()
        Me.lblAbilitiesPerk = New System.Windows.Forms.Label()
        Me.lblAbilitiesIP = New System.Windows.Forms.Label()
        Me.lblAbilitiesImp = New System.Windows.Forms.Label()
        Me.lblAbilitiesBuff = New System.Windows.Forms.Label()
        Me.lblAbilitiesEquip = New System.Windows.Forms.Label()
        Me.tabSkills1 = New System.Windows.Forms.TabPage()
        Me.lblBodyOrg = New System.Windows.Forms.Label()
        Me.lblBodyPerk = New System.Windows.Forms.Label()
        Me.lblBodyIP = New System.Windows.Forms.Label()
        Me.lblBodyImp = New System.Windows.Forms.Label()
        Me.lblBodyBuff = New System.Windows.Forms.Label()
        Me.lblBodyEquip = New System.Windows.Forms.Label()
        Me.tabSkills2 = New System.Windows.Forms.TabPage()
        Me.lblMeleeOrg = New System.Windows.Forms.Label()
        Me.lblMeleePerk = New System.Windows.Forms.Label()
        Me.lblMeleeIP = New System.Windows.Forms.Label()
        Me.lblMeleeImp = New System.Windows.Forms.Label()
        Me.lblMeleeBuff = New System.Windows.Forms.Label()
        Me.lblMeleeEquip = New System.Windows.Forms.Label()
        Me.tabSkills3 = New System.Windows.Forms.TabPage()
        Me.lblMeleeSpecOrg = New System.Windows.Forms.Label()
        Me.lblMeleeSpecPerk = New System.Windows.Forms.Label()
        Me.lblMeleeSpecIP = New System.Windows.Forms.Label()
        Me.lblMeleeSpecImp = New System.Windows.Forms.Label()
        Me.lblMeleeSpecBuff = New System.Windows.Forms.Label()
        Me.lblMeleeSpecEquip = New System.Windows.Forms.Label()
        Me.tabSkills4 = New System.Windows.Forms.TabPage()
        Me.lblRangedOrg = New System.Windows.Forms.Label()
        Me.lblRangedPerk = New System.Windows.Forms.Label()
        Me.lblRangedIP = New System.Windows.Forms.Label()
        Me.lblRangedImp = New System.Windows.Forms.Label()
        Me.lblRangedBuff = New System.Windows.Forms.Label()
        Me.lblRangedEquip = New System.Windows.Forms.Label()
        Me.tabSkills5 = New System.Windows.Forms.TabPage()
        Me.lblRangeSpecOrg = New System.Windows.Forms.Label()
        Me.lblRangeSpecPerk = New System.Windows.Forms.Label()
        Me.lblRangeSpecIP = New System.Windows.Forms.Label()
        Me.lblRangeSpecImp = New System.Windows.Forms.Label()
        Me.lblRangeSpecBuff = New System.Windows.Forms.Label()
        Me.lblRangeSpecEquip = New System.Windows.Forms.Label()
        Me.tabSkills6 = New System.Windows.Forms.TabPage()
        Me.lblNanoOrg = New System.Windows.Forms.Label()
        Me.lblNanoPerk = New System.Windows.Forms.Label()
        Me.lblNanoIP = New System.Windows.Forms.Label()
        Me.lblNanoImp = New System.Windows.Forms.Label()
        Me.lblNanoBuff = New System.Windows.Forms.Label()
        Me.lblNanoEquip = New System.Windows.Forms.Label()
        Me.tabSkills7 = New System.Windows.Forms.TabPage()
        Me.lblExploreOrg = New System.Windows.Forms.Label()
        Me.lblExplorePerk = New System.Windows.Forms.Label()
        Me.lblExploreIP = New System.Windows.Forms.Label()
        Me.lblExploreImp = New System.Windows.Forms.Label()
        Me.lblExploreBuff = New System.Windows.Forms.Label()
        Me.lblExploreEquip = New System.Windows.Forms.Label()
        Me.tabSkills8 = New System.Windows.Forms.TabPage()
        Me.lblCombatOrg = New System.Windows.Forms.Label()
        Me.lblCombatPerk = New System.Windows.Forms.Label()
        Me.lblCombatIP = New System.Windows.Forms.Label()
        Me.lblCombatImp = New System.Windows.Forms.Label()
        Me.lblCombatBuff = New System.Windows.Forms.Label()
        Me.lblCombatEquip = New System.Windows.Forms.Label()
        Me.tabSkills9 = New System.Windows.Forms.TabPage()
        Me.lblTradeOrg = New System.Windows.Forms.Label()
        Me.lblTradePerk = New System.Windows.Forms.Label()
        Me.lblTradeIP = New System.Windows.Forms.Label()
        Me.lblTradeImp = New System.Windows.Forms.Label()
        Me.lblTradeBuff = New System.Windows.Forms.Label()
        Me.lblTradeEquip = New System.Windows.Forms.Label()
        Me.tabSkills10 = New System.Windows.Forms.TabPage()
        Me.lblLegacyOrg = New System.Windows.Forms.Label()
        Me.lblLegacyPerk = New System.Windows.Forms.Label()
        Me.lblLegacyIP = New System.Windows.Forms.Label()
        Me.lblLegacyImp = New System.Windows.Forms.Label()
        Me.lblLegacyBuff = New System.Windows.Forms.Label()
        Me.lblLegacyEquip = New System.Windows.Forms.Label()
        Me.tabPerks = New System.Windows.Forms.TabPage()
        Me.lblPerkPoints = New System.Windows.Forms.Label()
        Me.lblPerkList = New System.Windows.Forms.Label()
        Me.lstPerks = New System.Windows.Forms.ListBox()
        Me.tabAIPerks = New System.Windows.Forms.TabPage()
        Me.lblAIPerks = New System.Windows.Forms.Label()
        Me.Label67 = New System.Windows.Forms.Label()
        Me.nudAlienTitle = New System.Windows.Forms.NumericUpDown()
        Me.lstAIPerks = New System.Windows.Forms.ListBox()
        Me.tabResearch = New System.Windows.Forms.TabPage()
        Me.lstResearch = New System.Windows.Forms.ListBox()
        Me.tabOthers = New System.Windows.Forms.TabPage()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu(Me.components)
        Me.miFile = New System.Windows.Forms.MenuItem()
        Me.meOpen = New System.Windows.Forms.MenuItem()
        Me.meOpenRawData = New System.Windows.Forms.MenuItem()
        Me.meSave = New System.Windows.Forms.MenuItem()
        Me.meSaveAs = New System.Windows.Forms.MenuItem()
        Me.mePrintPreview = New System.Windows.Forms.MenuItem()
        Me.mePrint = New System.Windows.Forms.MenuItem()
        Me.meExit = New System.Windows.Forms.MenuItem()
        Me.miEdit = New System.Windows.Forms.MenuItem()
        Me.meReset = New System.Windows.Forms.MenuItem()
        Me.meMaxAttr = New System.Windows.Forms.MenuItem()
        Me.miLogging = New System.Windows.Forms.MenuItem()
        Me.meLoggingToggle = New System.Windows.Forms.MenuItem()
        Me.miBuffs = New System.Windows.Forms.MenuItem()
        Me.meClearBuff = New System.Windows.Forms.MenuItem()
        Me.MenuItem10 = New System.Windows.Forms.MenuItem()
        Me.meManageBuffs = New System.Windows.Forms.MenuItem()
        Me.miPerks = New System.Windows.Forms.MenuItem()
        Me.meClearPerks = New System.Windows.Forms.MenuItem()
        Me.meLoadPerks = New System.Windows.Forms.MenuItem()
        Me.meSavePerks = New System.Windows.Forms.MenuItem()
        Me.miEquipment = New System.Windows.Forms.MenuItem()
        Me.meEquipConfig = New System.Windows.Forms.MenuItem()
        Me.meImplantConfig = New System.Windows.Forms.MenuItem()
        Me.miOrgs = New System.Windows.Forms.MenuItem()
        Me.meClearMisc = New System.Windows.Forms.MenuItem()
        Me.MenuItem13 = New System.Windows.Forms.MenuItem()
        Me.meManageMisc = New System.Windows.Forms.MenuItem()
        Me.MenuItem14 = New System.Windows.Forms.MenuItem()
        Me.meLoadMisc = New System.Windows.Forms.MenuItem()
        Me.meSaveMisc = New System.Windows.Forms.MenuItem()
        Me.miHelp = New System.Windows.Forms.MenuItem()
        Me.meAbout = New System.Windows.Forms.MenuItem()
        Me.MenuItem1 = New System.Windows.Forms.MenuItem()
        Me.meResetIH = New System.Windows.Forms.MenuItem()
        Me.meResetBC = New System.Windows.Forms.MenuItem()
        Me.fdOpen = New System.Windows.Forms.OpenFileDialog()
        Me.fdSave = New System.Windows.Forms.SaveFileDialog()
        Me.sePrintDocument = New System.Drawing.Printing.PrintDocument()
        Me.fdSaveBuff = New System.Windows.Forms.SaveFileDialog()
        Me.fdOpenImp = New System.Windows.Forms.OpenFileDialog()
        Me.fdSaveImp = New System.Windows.Forms.SaveFileDialog()
        Me.fdOpenEqu = New System.Windows.Forms.OpenFileDialog()
        Me.fdSaveEqu = New System.Windows.Forms.SaveFileDialog()
        Me.fdOpenPerk = New System.Windows.Forms.OpenFileDialog()
        Me.fdSavePerk = New System.Windows.Forms.SaveFileDialog()
        Me.fdOpenMisc = New System.Windows.Forms.OpenFileDialog()
        Me.fdSaveMisc = New System.Windows.Forms.SaveFileDialog()
        Me.sbInfo = New System.Windows.Forms.StatusBar()
        Me.fdOpenRawData = New System.Windows.Forms.OpenFileDialog()
        Me.FlowLayoutPanel1 = New System.Windows.Forms.FlowLayoutPanel()
        Me.Label7 = New System.Windows.Forms.Label()
        Me.nudLevel = New System.Windows.Forms.NumericUpDown()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.cmbProf = New System.Windows.Forms.ComboBox()
        Me.Label9 = New System.Windows.Forms.Label()
        Me.cmbBreed = New System.Windows.Forms.ComboBox()
        Me.Label12 = New System.Windows.Forms.Label()
        Me.lblIP = New System.Windows.Forms.Label()
        Me.tabControls.SuspendLayout()
        Me.tabAttr.SuspendLayout()
        Me.tabSkills1.SuspendLayout()
        Me.tabSkills2.SuspendLayout()
        Me.tabSkills3.SuspendLayout()
        Me.tabSkills4.SuspendLayout()
        Me.tabSkills5.SuspendLayout()
        Me.tabSkills6.SuspendLayout()
        Me.tabSkills7.SuspendLayout()
        Me.tabSkills8.SuspendLayout()
        Me.tabSkills9.SuspendLayout()
        Me.tabSkills10.SuspendLayout()
        Me.tabPerks.SuspendLayout()
        Me.tabAIPerks.SuspendLayout()
        CType(Me.nudAlienTitle, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.tabResearch.SuspendLayout()
        Me.FlowLayoutPanel1.SuspendLayout()
        CType(Me.nudLevel, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'tabControls
        '
        Me.tabControls.Controls.Add(Me.tabAttr)
        Me.tabControls.Controls.Add(Me.tabSkills1)
        Me.tabControls.Controls.Add(Me.tabSkills2)
        Me.tabControls.Controls.Add(Me.tabSkills3)
        Me.tabControls.Controls.Add(Me.tabSkills4)
        Me.tabControls.Controls.Add(Me.tabSkills5)
        Me.tabControls.Controls.Add(Me.tabSkills6)
        Me.tabControls.Controls.Add(Me.tabSkills7)
        Me.tabControls.Controls.Add(Me.tabSkills8)
        Me.tabControls.Controls.Add(Me.tabSkills9)
        Me.tabControls.Controls.Add(Me.tabSkills10)
        Me.tabControls.Controls.Add(Me.tabPerks)
        Me.tabControls.Controls.Add(Me.tabAIPerks)
        Me.tabControls.Controls.Add(Me.tabResearch)
        Me.tabControls.Controls.Add(Me.tabOthers)
        Me.tabControls.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tabControls.Location = New System.Drawing.Point(8, 40)
        Me.tabControls.Name = "tabControls"
        Me.tabControls.SelectedIndex = 0
        Me.tabControls.Size = New System.Drawing.Size(912, 456)
        Me.tabControls.TabIndex = 0
        '
        'tabAttr
        '
        Me.tabAttr.Controls.Add(Me.lblAbilitiesOrg)
        Me.tabAttr.Controls.Add(Me.lblAbilitiesPerk)
        Me.tabAttr.Controls.Add(Me.lblAbilitiesIP)
        Me.tabAttr.Controls.Add(Me.lblAbilitiesImp)
        Me.tabAttr.Controls.Add(Me.lblAbilitiesBuff)
        Me.tabAttr.Controls.Add(Me.lblAbilitiesEquip)
        Me.tabAttr.Location = New System.Drawing.Point(4, 23)
        Me.tabAttr.Name = "tabAttr"
        Me.tabAttr.Size = New System.Drawing.Size(904, 429)
        Me.tabAttr.TabIndex = 0
        Me.tabAttr.Text = "Abilities"
        '
        'lblAbilitiesOrg
        '
        Me.lblAbilitiesOrg.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblAbilitiesOrg.Location = New System.Drawing.Point(552, 4)
        Me.lblAbilitiesOrg.Name = "lblAbilitiesOrg"
        Me.lblAbilitiesOrg.Size = New System.Drawing.Size(44, 26)
        Me.lblAbilitiesOrg.TabIndex = 12
        Me.lblAbilitiesOrg.Text = "Org"
        Me.lblAbilitiesOrg.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblAbilitiesPerk
        '
        Me.lblAbilitiesPerk.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblAbilitiesPerk.Location = New System.Drawing.Point(496, 4)
        Me.lblAbilitiesPerk.Name = "lblAbilitiesPerk"
        Me.lblAbilitiesPerk.Size = New System.Drawing.Size(44, 26)
        Me.lblAbilitiesPerk.TabIndex = 11
        Me.lblAbilitiesPerk.Text = "Perk"
        Me.lblAbilitiesPerk.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblAbilitiesIP
        '
        Me.lblAbilitiesIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblAbilitiesIP.Location = New System.Drawing.Point(272, 4)
        Me.lblAbilitiesIP.Name = "lblAbilitiesIP"
        Me.lblAbilitiesIP.Size = New System.Drawing.Size(44, 26)
        Me.lblAbilitiesIP.TabIndex = 6
        Me.lblAbilitiesIP.Text = "IP"
        Me.lblAbilitiesIP.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblAbilitiesImp
        '
        Me.lblAbilitiesImp.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblAbilitiesImp.Location = New System.Drawing.Point(328, 4)
        Me.lblAbilitiesImp.Name = "lblAbilitiesImp"
        Me.lblAbilitiesImp.Size = New System.Drawing.Size(44, 26)
        Me.lblAbilitiesImp.TabIndex = 5
        Me.lblAbilitiesImp.Text = "Imp"
        Me.lblAbilitiesImp.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblAbilitiesBuff
        '
        Me.lblAbilitiesBuff.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblAbilitiesBuff.Location = New System.Drawing.Point(384, 4)
        Me.lblAbilitiesBuff.Name = "lblAbilitiesBuff"
        Me.lblAbilitiesBuff.Size = New System.Drawing.Size(44, 26)
        Me.lblAbilitiesBuff.TabIndex = 4
        Me.lblAbilitiesBuff.Text = "Buff"
        Me.lblAbilitiesBuff.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblAbilitiesEquip
        '
        Me.lblAbilitiesEquip.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblAbilitiesEquip.Location = New System.Drawing.Point(440, 4)
        Me.lblAbilitiesEquip.Name = "lblAbilitiesEquip"
        Me.lblAbilitiesEquip.Size = New System.Drawing.Size(44, 26)
        Me.lblAbilitiesEquip.TabIndex = 3
        Me.lblAbilitiesEquip.Text = "Equip"
        Me.lblAbilitiesEquip.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'tabSkills1
        '
        Me.tabSkills1.Controls.Add(Me.lblBodyOrg)
        Me.tabSkills1.Controls.Add(Me.lblBodyPerk)
        Me.tabSkills1.Controls.Add(Me.lblBodyIP)
        Me.tabSkills1.Controls.Add(Me.lblBodyImp)
        Me.tabSkills1.Controls.Add(Me.lblBodyBuff)
        Me.tabSkills1.Controls.Add(Me.lblBodyEquip)
        Me.tabSkills1.Location = New System.Drawing.Point(4, 23)
        Me.tabSkills1.Name = "tabSkills1"
        Me.tabSkills1.Size = New System.Drawing.Size(904, 429)
        Me.tabSkills1.TabIndex = 1
        Me.tabSkills1.Text = "Body & Def."
        '
        'lblBodyOrg
        '
        Me.lblBodyOrg.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblBodyOrg.Location = New System.Drawing.Point(552, 4)
        Me.lblBodyOrg.Name = "lblBodyOrg"
        Me.lblBodyOrg.Size = New System.Drawing.Size(44, 26)
        Me.lblBodyOrg.TabIndex = 13
        Me.lblBodyOrg.Text = "Org"
        Me.lblBodyOrg.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblBodyPerk
        '
        Me.lblBodyPerk.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblBodyPerk.Location = New System.Drawing.Point(496, 4)
        Me.lblBodyPerk.Name = "lblBodyPerk"
        Me.lblBodyPerk.Size = New System.Drawing.Size(44, 26)
        Me.lblBodyPerk.TabIndex = 12
        Me.lblBodyPerk.Text = "Perk"
        Me.lblBodyPerk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblBodyIP
        '
        Me.lblBodyIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblBodyIP.Location = New System.Drawing.Point(272, 4)
        Me.lblBodyIP.Name = "lblBodyIP"
        Me.lblBodyIP.Size = New System.Drawing.Size(44, 26)
        Me.lblBodyIP.TabIndex = 10
        Me.lblBodyIP.Text = "IP"
        Me.lblBodyIP.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblBodyImp
        '
        Me.lblBodyImp.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblBodyImp.Location = New System.Drawing.Point(328, 4)
        Me.lblBodyImp.Name = "lblBodyImp"
        Me.lblBodyImp.Size = New System.Drawing.Size(44, 26)
        Me.lblBodyImp.TabIndex = 9
        Me.lblBodyImp.Text = "Imp"
        Me.lblBodyImp.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblBodyBuff
        '
        Me.lblBodyBuff.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblBodyBuff.Location = New System.Drawing.Point(384, 4)
        Me.lblBodyBuff.Name = "lblBodyBuff"
        Me.lblBodyBuff.Size = New System.Drawing.Size(44, 26)
        Me.lblBodyBuff.TabIndex = 8
        Me.lblBodyBuff.Text = "Buff"
        Me.lblBodyBuff.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblBodyEquip
        '
        Me.lblBodyEquip.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblBodyEquip.Location = New System.Drawing.Point(440, 4)
        Me.lblBodyEquip.Name = "lblBodyEquip"
        Me.lblBodyEquip.Size = New System.Drawing.Size(44, 26)
        Me.lblBodyEquip.TabIndex = 7
        Me.lblBodyEquip.Text = "Equip"
        Me.lblBodyEquip.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'tabSkills2
        '
        Me.tabSkills2.Controls.Add(Me.lblMeleeOrg)
        Me.tabSkills2.Controls.Add(Me.lblMeleePerk)
        Me.tabSkills2.Controls.Add(Me.lblMeleeIP)
        Me.tabSkills2.Controls.Add(Me.lblMeleeImp)
        Me.tabSkills2.Controls.Add(Me.lblMeleeBuff)
        Me.tabSkills2.Controls.Add(Me.lblMeleeEquip)
        Me.tabSkills2.Location = New System.Drawing.Point(4, 23)
        Me.tabSkills2.Name = "tabSkills2"
        Me.tabSkills2.Size = New System.Drawing.Size(904, 429)
        Me.tabSkills2.TabIndex = 2
        Me.tabSkills2.Text = "Melee Wpns."
        '
        'lblMeleeOrg
        '
        Me.lblMeleeOrg.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleeOrg.Location = New System.Drawing.Point(552, 4)
        Me.lblMeleeOrg.Name = "lblMeleeOrg"
        Me.lblMeleeOrg.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleeOrg.TabIndex = 14
        Me.lblMeleeOrg.Text = "Org"
        Me.lblMeleeOrg.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblMeleePerk
        '
        Me.lblMeleePerk.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleePerk.Location = New System.Drawing.Point(496, 4)
        Me.lblMeleePerk.Name = "lblMeleePerk"
        Me.lblMeleePerk.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleePerk.TabIndex = 12
        Me.lblMeleePerk.Text = "Perk"
        Me.lblMeleePerk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblMeleeIP
        '
        Me.lblMeleeIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleeIP.Location = New System.Drawing.Point(272, 4)
        Me.lblMeleeIP.Name = "lblMeleeIP"
        Me.lblMeleeIP.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleeIP.TabIndex = 10
        Me.lblMeleeIP.Text = "IP"
        Me.lblMeleeIP.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblMeleeImp
        '
        Me.lblMeleeImp.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleeImp.Location = New System.Drawing.Point(328, 4)
        Me.lblMeleeImp.Name = "lblMeleeImp"
        Me.lblMeleeImp.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleeImp.TabIndex = 9
        Me.lblMeleeImp.Text = "Imp"
        Me.lblMeleeImp.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblMeleeBuff
        '
        Me.lblMeleeBuff.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleeBuff.Location = New System.Drawing.Point(384, 4)
        Me.lblMeleeBuff.Name = "lblMeleeBuff"
        Me.lblMeleeBuff.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleeBuff.TabIndex = 8
        Me.lblMeleeBuff.Text = "Buff"
        Me.lblMeleeBuff.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblMeleeEquip
        '
        Me.lblMeleeEquip.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleeEquip.Location = New System.Drawing.Point(440, 4)
        Me.lblMeleeEquip.Name = "lblMeleeEquip"
        Me.lblMeleeEquip.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleeEquip.TabIndex = 7
        Me.lblMeleeEquip.Text = "Equip"
        Me.lblMeleeEquip.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'tabSkills3
        '
        Me.tabSkills3.Controls.Add(Me.lblMeleeSpecOrg)
        Me.tabSkills3.Controls.Add(Me.lblMeleeSpecPerk)
        Me.tabSkills3.Controls.Add(Me.lblMeleeSpecIP)
        Me.tabSkills3.Controls.Add(Me.lblMeleeSpecImp)
        Me.tabSkills3.Controls.Add(Me.lblMeleeSpecBuff)
        Me.tabSkills3.Controls.Add(Me.lblMeleeSpecEquip)
        Me.tabSkills3.Location = New System.Drawing.Point(4, 23)
        Me.tabSkills3.Name = "tabSkills3"
        Me.tabSkills3.Size = New System.Drawing.Size(904, 429)
        Me.tabSkills3.TabIndex = 3
        Me.tabSkills3.Text = "Melee Spec."
        '
        'lblMeleeSpecOrg
        '
        Me.lblMeleeSpecOrg.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleeSpecOrg.Location = New System.Drawing.Point(552, 4)
        Me.lblMeleeSpecOrg.Name = "lblMeleeSpecOrg"
        Me.lblMeleeSpecOrg.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleeSpecOrg.TabIndex = 16
        Me.lblMeleeSpecOrg.Text = "Org"
        Me.lblMeleeSpecOrg.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblMeleeSpecPerk
        '
        Me.lblMeleeSpecPerk.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleeSpecPerk.Location = New System.Drawing.Point(496, 4)
        Me.lblMeleeSpecPerk.Name = "lblMeleeSpecPerk"
        Me.lblMeleeSpecPerk.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleeSpecPerk.TabIndex = 15
        Me.lblMeleeSpecPerk.Text = "Perk"
        Me.lblMeleeSpecPerk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblMeleeSpecIP
        '
        Me.lblMeleeSpecIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleeSpecIP.Location = New System.Drawing.Point(272, 4)
        Me.lblMeleeSpecIP.Name = "lblMeleeSpecIP"
        Me.lblMeleeSpecIP.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleeSpecIP.TabIndex = 14
        Me.lblMeleeSpecIP.Text = "IP"
        Me.lblMeleeSpecIP.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblMeleeSpecImp
        '
        Me.lblMeleeSpecImp.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleeSpecImp.Location = New System.Drawing.Point(328, 4)
        Me.lblMeleeSpecImp.Name = "lblMeleeSpecImp"
        Me.lblMeleeSpecImp.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleeSpecImp.TabIndex = 13
        Me.lblMeleeSpecImp.Text = "Imp"
        Me.lblMeleeSpecImp.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblMeleeSpecBuff
        '
        Me.lblMeleeSpecBuff.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleeSpecBuff.Location = New System.Drawing.Point(384, 4)
        Me.lblMeleeSpecBuff.Name = "lblMeleeSpecBuff"
        Me.lblMeleeSpecBuff.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleeSpecBuff.TabIndex = 12
        Me.lblMeleeSpecBuff.Text = "Buff"
        Me.lblMeleeSpecBuff.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblMeleeSpecEquip
        '
        Me.lblMeleeSpecEquip.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMeleeSpecEquip.Location = New System.Drawing.Point(440, 4)
        Me.lblMeleeSpecEquip.Name = "lblMeleeSpecEquip"
        Me.lblMeleeSpecEquip.Size = New System.Drawing.Size(44, 26)
        Me.lblMeleeSpecEquip.TabIndex = 11
        Me.lblMeleeSpecEquip.Text = "Equip"
        Me.lblMeleeSpecEquip.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'tabSkills4
        '
        Me.tabSkills4.Controls.Add(Me.lblRangedOrg)
        Me.tabSkills4.Controls.Add(Me.lblRangedPerk)
        Me.tabSkills4.Controls.Add(Me.lblRangedIP)
        Me.tabSkills4.Controls.Add(Me.lblRangedImp)
        Me.tabSkills4.Controls.Add(Me.lblRangedBuff)
        Me.tabSkills4.Controls.Add(Me.lblRangedEquip)
        Me.tabSkills4.Location = New System.Drawing.Point(4, 23)
        Me.tabSkills4.Name = "tabSkills4"
        Me.tabSkills4.Size = New System.Drawing.Size(904, 429)
        Me.tabSkills4.TabIndex = 4
        Me.tabSkills4.Text = "Ranged Wpns."
        '
        'lblRangedOrg
        '
        Me.lblRangedOrg.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangedOrg.Location = New System.Drawing.Point(552, 4)
        Me.lblRangedOrg.Name = "lblRangedOrg"
        Me.lblRangedOrg.Size = New System.Drawing.Size(44, 26)
        Me.lblRangedOrg.TabIndex = 16
        Me.lblRangedOrg.Text = "Org"
        Me.lblRangedOrg.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblRangedPerk
        '
        Me.lblRangedPerk.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangedPerk.Location = New System.Drawing.Point(496, 4)
        Me.lblRangedPerk.Name = "lblRangedPerk"
        Me.lblRangedPerk.Size = New System.Drawing.Size(44, 26)
        Me.lblRangedPerk.TabIndex = 15
        Me.lblRangedPerk.Text = "Perk"
        Me.lblRangedPerk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblRangedIP
        '
        Me.lblRangedIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangedIP.Location = New System.Drawing.Point(272, 4)
        Me.lblRangedIP.Name = "lblRangedIP"
        Me.lblRangedIP.Size = New System.Drawing.Size(44, 26)
        Me.lblRangedIP.TabIndex = 14
        Me.lblRangedIP.Text = "IP"
        Me.lblRangedIP.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblRangedImp
        '
        Me.lblRangedImp.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangedImp.Location = New System.Drawing.Point(328, 4)
        Me.lblRangedImp.Name = "lblRangedImp"
        Me.lblRangedImp.Size = New System.Drawing.Size(44, 26)
        Me.lblRangedImp.TabIndex = 13
        Me.lblRangedImp.Text = "Imp"
        Me.lblRangedImp.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblRangedBuff
        '
        Me.lblRangedBuff.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangedBuff.Location = New System.Drawing.Point(384, 4)
        Me.lblRangedBuff.Name = "lblRangedBuff"
        Me.lblRangedBuff.Size = New System.Drawing.Size(44, 26)
        Me.lblRangedBuff.TabIndex = 12
        Me.lblRangedBuff.Text = "Buff"
        Me.lblRangedBuff.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblRangedEquip
        '
        Me.lblRangedEquip.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangedEquip.Location = New System.Drawing.Point(440, 4)
        Me.lblRangedEquip.Name = "lblRangedEquip"
        Me.lblRangedEquip.Size = New System.Drawing.Size(44, 26)
        Me.lblRangedEquip.TabIndex = 11
        Me.lblRangedEquip.Text = "Equip"
        Me.lblRangedEquip.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'tabSkills5
        '
        Me.tabSkills5.Controls.Add(Me.lblRangeSpecOrg)
        Me.tabSkills5.Controls.Add(Me.lblRangeSpecPerk)
        Me.tabSkills5.Controls.Add(Me.lblRangeSpecIP)
        Me.tabSkills5.Controls.Add(Me.lblRangeSpecImp)
        Me.tabSkills5.Controls.Add(Me.lblRangeSpecBuff)
        Me.tabSkills5.Controls.Add(Me.lblRangeSpecEquip)
        Me.tabSkills5.Location = New System.Drawing.Point(4, 23)
        Me.tabSkills5.Name = "tabSkills5"
        Me.tabSkills5.Size = New System.Drawing.Size(904, 429)
        Me.tabSkills5.TabIndex = 5
        Me.tabSkills5.Text = "Ranged Spec."
        '
        'lblRangeSpecOrg
        '
        Me.lblRangeSpecOrg.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangeSpecOrg.Location = New System.Drawing.Point(552, 4)
        Me.lblRangeSpecOrg.Name = "lblRangeSpecOrg"
        Me.lblRangeSpecOrg.Size = New System.Drawing.Size(44, 26)
        Me.lblRangeSpecOrg.TabIndex = 16
        Me.lblRangeSpecOrg.Text = "Org"
        Me.lblRangeSpecOrg.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblRangeSpecPerk
        '
        Me.lblRangeSpecPerk.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangeSpecPerk.Location = New System.Drawing.Point(496, 4)
        Me.lblRangeSpecPerk.Name = "lblRangeSpecPerk"
        Me.lblRangeSpecPerk.Size = New System.Drawing.Size(44, 26)
        Me.lblRangeSpecPerk.TabIndex = 15
        Me.lblRangeSpecPerk.Text = "Perk"
        Me.lblRangeSpecPerk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblRangeSpecIP
        '
        Me.lblRangeSpecIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangeSpecIP.Location = New System.Drawing.Point(272, 4)
        Me.lblRangeSpecIP.Name = "lblRangeSpecIP"
        Me.lblRangeSpecIP.Size = New System.Drawing.Size(44, 26)
        Me.lblRangeSpecIP.TabIndex = 14
        Me.lblRangeSpecIP.Text = "IP"
        Me.lblRangeSpecIP.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblRangeSpecImp
        '
        Me.lblRangeSpecImp.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangeSpecImp.Location = New System.Drawing.Point(328, 4)
        Me.lblRangeSpecImp.Name = "lblRangeSpecImp"
        Me.lblRangeSpecImp.Size = New System.Drawing.Size(44, 26)
        Me.lblRangeSpecImp.TabIndex = 13
        Me.lblRangeSpecImp.Text = "Imp"
        Me.lblRangeSpecImp.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblRangeSpecBuff
        '
        Me.lblRangeSpecBuff.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangeSpecBuff.Location = New System.Drawing.Point(384, 4)
        Me.lblRangeSpecBuff.Name = "lblRangeSpecBuff"
        Me.lblRangeSpecBuff.Size = New System.Drawing.Size(44, 26)
        Me.lblRangeSpecBuff.TabIndex = 12
        Me.lblRangeSpecBuff.Text = "Buff"
        Me.lblRangeSpecBuff.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblRangeSpecEquip
        '
        Me.lblRangeSpecEquip.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRangeSpecEquip.Location = New System.Drawing.Point(440, 4)
        Me.lblRangeSpecEquip.Name = "lblRangeSpecEquip"
        Me.lblRangeSpecEquip.Size = New System.Drawing.Size(44, 26)
        Me.lblRangeSpecEquip.TabIndex = 11
        Me.lblRangeSpecEquip.Text = "Equip"
        Me.lblRangeSpecEquip.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'tabSkills6
        '
        Me.tabSkills6.Controls.Add(Me.lblNanoOrg)
        Me.tabSkills6.Controls.Add(Me.lblNanoPerk)
        Me.tabSkills6.Controls.Add(Me.lblNanoIP)
        Me.tabSkills6.Controls.Add(Me.lblNanoImp)
        Me.tabSkills6.Controls.Add(Me.lblNanoBuff)
        Me.tabSkills6.Controls.Add(Me.lblNanoEquip)
        Me.tabSkills6.Location = New System.Drawing.Point(4, 23)
        Me.tabSkills6.Name = "tabSkills6"
        Me.tabSkills6.Size = New System.Drawing.Size(904, 429)
        Me.tabSkills6.TabIndex = 6
        Me.tabSkills6.Text = "Nano & Casting"
        '
        'lblNanoOrg
        '
        Me.lblNanoOrg.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblNanoOrg.Location = New System.Drawing.Point(552, 4)
        Me.lblNanoOrg.Name = "lblNanoOrg"
        Me.lblNanoOrg.Size = New System.Drawing.Size(44, 26)
        Me.lblNanoOrg.TabIndex = 16
        Me.lblNanoOrg.Text = "Org"
        Me.lblNanoOrg.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblNanoPerk
        '
        Me.lblNanoPerk.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblNanoPerk.Location = New System.Drawing.Point(496, 4)
        Me.lblNanoPerk.Name = "lblNanoPerk"
        Me.lblNanoPerk.Size = New System.Drawing.Size(44, 26)
        Me.lblNanoPerk.TabIndex = 15
        Me.lblNanoPerk.Text = "Perk"
        Me.lblNanoPerk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblNanoIP
        '
        Me.lblNanoIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblNanoIP.Location = New System.Drawing.Point(272, 4)
        Me.lblNanoIP.Name = "lblNanoIP"
        Me.lblNanoIP.Size = New System.Drawing.Size(44, 26)
        Me.lblNanoIP.TabIndex = 14
        Me.lblNanoIP.Text = "IP"
        Me.lblNanoIP.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblNanoImp
        '
        Me.lblNanoImp.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblNanoImp.Location = New System.Drawing.Point(328, 4)
        Me.lblNanoImp.Name = "lblNanoImp"
        Me.lblNanoImp.Size = New System.Drawing.Size(44, 26)
        Me.lblNanoImp.TabIndex = 13
        Me.lblNanoImp.Text = "Imp"
        Me.lblNanoImp.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblNanoBuff
        '
        Me.lblNanoBuff.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblNanoBuff.Location = New System.Drawing.Point(384, 4)
        Me.lblNanoBuff.Name = "lblNanoBuff"
        Me.lblNanoBuff.Size = New System.Drawing.Size(44, 26)
        Me.lblNanoBuff.TabIndex = 12
        Me.lblNanoBuff.Text = "Buff"
        Me.lblNanoBuff.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblNanoEquip
        '
        Me.lblNanoEquip.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblNanoEquip.Location = New System.Drawing.Point(440, 4)
        Me.lblNanoEquip.Name = "lblNanoEquip"
        Me.lblNanoEquip.Size = New System.Drawing.Size(44, 26)
        Me.lblNanoEquip.TabIndex = 11
        Me.lblNanoEquip.Text = "Equip"
        Me.lblNanoEquip.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'tabSkills7
        '
        Me.tabSkills7.Controls.Add(Me.lblExploreOrg)
        Me.tabSkills7.Controls.Add(Me.lblExplorePerk)
        Me.tabSkills7.Controls.Add(Me.lblExploreIP)
        Me.tabSkills7.Controls.Add(Me.lblExploreImp)
        Me.tabSkills7.Controls.Add(Me.lblExploreBuff)
        Me.tabSkills7.Controls.Add(Me.lblExploreEquip)
        Me.tabSkills7.Location = New System.Drawing.Point(4, 23)
        Me.tabSkills7.Name = "tabSkills7"
        Me.tabSkills7.Size = New System.Drawing.Size(904, 429)
        Me.tabSkills7.TabIndex = 7
        Me.tabSkills7.Text = "Exploring"
        '
        'lblExploreOrg
        '
        Me.lblExploreOrg.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblExploreOrg.Location = New System.Drawing.Point(552, 4)
        Me.lblExploreOrg.Name = "lblExploreOrg"
        Me.lblExploreOrg.Size = New System.Drawing.Size(44, 26)
        Me.lblExploreOrg.TabIndex = 16
        Me.lblExploreOrg.Text = "Org"
        Me.lblExploreOrg.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblExplorePerk
        '
        Me.lblExplorePerk.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblExplorePerk.Location = New System.Drawing.Point(496, 4)
        Me.lblExplorePerk.Name = "lblExplorePerk"
        Me.lblExplorePerk.Size = New System.Drawing.Size(44, 26)
        Me.lblExplorePerk.TabIndex = 15
        Me.lblExplorePerk.Text = "Perk"
        Me.lblExplorePerk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblExploreIP
        '
        Me.lblExploreIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblExploreIP.Location = New System.Drawing.Point(272, 4)
        Me.lblExploreIP.Name = "lblExploreIP"
        Me.lblExploreIP.Size = New System.Drawing.Size(44, 26)
        Me.lblExploreIP.TabIndex = 14
        Me.lblExploreIP.Text = "IP"
        Me.lblExploreIP.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblExploreImp
        '
        Me.lblExploreImp.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblExploreImp.Location = New System.Drawing.Point(328, 4)
        Me.lblExploreImp.Name = "lblExploreImp"
        Me.lblExploreImp.Size = New System.Drawing.Size(44, 26)
        Me.lblExploreImp.TabIndex = 13
        Me.lblExploreImp.Text = "Imp"
        Me.lblExploreImp.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblExploreBuff
        '
        Me.lblExploreBuff.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblExploreBuff.Location = New System.Drawing.Point(384, 4)
        Me.lblExploreBuff.Name = "lblExploreBuff"
        Me.lblExploreBuff.Size = New System.Drawing.Size(44, 26)
        Me.lblExploreBuff.TabIndex = 12
        Me.lblExploreBuff.Text = "Buff"
        Me.lblExploreBuff.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblExploreEquip
        '
        Me.lblExploreEquip.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblExploreEquip.Location = New System.Drawing.Point(440, 4)
        Me.lblExploreEquip.Name = "lblExploreEquip"
        Me.lblExploreEquip.Size = New System.Drawing.Size(44, 26)
        Me.lblExploreEquip.TabIndex = 11
        Me.lblExploreEquip.Text = "Equip"
        Me.lblExploreEquip.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'tabSkills8
        '
        Me.tabSkills8.Controls.Add(Me.lblCombatOrg)
        Me.tabSkills8.Controls.Add(Me.lblCombatPerk)
        Me.tabSkills8.Controls.Add(Me.lblCombatIP)
        Me.tabSkills8.Controls.Add(Me.lblCombatImp)
        Me.tabSkills8.Controls.Add(Me.lblCombatBuff)
        Me.tabSkills8.Controls.Add(Me.lblCombatEquip)
        Me.tabSkills8.Location = New System.Drawing.Point(4, 23)
        Me.tabSkills8.Name = "tabSkills8"
        Me.tabSkills8.Size = New System.Drawing.Size(904, 429)
        Me.tabSkills8.TabIndex = 8
        Me.tabSkills8.Text = "Combat & Healing"
        '
        'lblCombatOrg
        '
        Me.lblCombatOrg.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblCombatOrg.Location = New System.Drawing.Point(552, 4)
        Me.lblCombatOrg.Name = "lblCombatOrg"
        Me.lblCombatOrg.Size = New System.Drawing.Size(44, 26)
        Me.lblCombatOrg.TabIndex = 17
        Me.lblCombatOrg.Text = "Org"
        Me.lblCombatOrg.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblCombatPerk
        '
        Me.lblCombatPerk.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblCombatPerk.Location = New System.Drawing.Point(496, 4)
        Me.lblCombatPerk.Name = "lblCombatPerk"
        Me.lblCombatPerk.Size = New System.Drawing.Size(44, 26)
        Me.lblCombatPerk.TabIndex = 15
        Me.lblCombatPerk.Text = "Perk"
        Me.lblCombatPerk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblCombatIP
        '
        Me.lblCombatIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblCombatIP.Location = New System.Drawing.Point(272, 4)
        Me.lblCombatIP.Name = "lblCombatIP"
        Me.lblCombatIP.Size = New System.Drawing.Size(44, 26)
        Me.lblCombatIP.TabIndex = 14
        Me.lblCombatIP.Text = "IP"
        Me.lblCombatIP.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblCombatImp
        '
        Me.lblCombatImp.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblCombatImp.Location = New System.Drawing.Point(328, 4)
        Me.lblCombatImp.Name = "lblCombatImp"
        Me.lblCombatImp.Size = New System.Drawing.Size(44, 26)
        Me.lblCombatImp.TabIndex = 13
        Me.lblCombatImp.Text = "Imp"
        Me.lblCombatImp.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblCombatBuff
        '
        Me.lblCombatBuff.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblCombatBuff.Location = New System.Drawing.Point(384, 4)
        Me.lblCombatBuff.Name = "lblCombatBuff"
        Me.lblCombatBuff.Size = New System.Drawing.Size(44, 26)
        Me.lblCombatBuff.TabIndex = 12
        Me.lblCombatBuff.Text = "Buff"
        Me.lblCombatBuff.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblCombatEquip
        '
        Me.lblCombatEquip.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblCombatEquip.Location = New System.Drawing.Point(440, 4)
        Me.lblCombatEquip.Name = "lblCombatEquip"
        Me.lblCombatEquip.Size = New System.Drawing.Size(44, 26)
        Me.lblCombatEquip.TabIndex = 11
        Me.lblCombatEquip.Text = "Equip"
        Me.lblCombatEquip.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'tabSkills9
        '
        Me.tabSkills9.Controls.Add(Me.lblTradeOrg)
        Me.tabSkills9.Controls.Add(Me.lblTradePerk)
        Me.tabSkills9.Controls.Add(Me.lblTradeIP)
        Me.tabSkills9.Controls.Add(Me.lblTradeImp)
        Me.tabSkills9.Controls.Add(Me.lblTradeBuff)
        Me.tabSkills9.Controls.Add(Me.lblTradeEquip)
        Me.tabSkills9.Location = New System.Drawing.Point(4, 23)
        Me.tabSkills9.Name = "tabSkills9"
        Me.tabSkills9.Size = New System.Drawing.Size(904, 429)
        Me.tabSkills9.TabIndex = 9
        Me.tabSkills9.Text = "Trade & Repair"
        '
        'lblTradeOrg
        '
        Me.lblTradeOrg.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTradeOrg.Location = New System.Drawing.Point(552, 4)
        Me.lblTradeOrg.Name = "lblTradeOrg"
        Me.lblTradeOrg.Size = New System.Drawing.Size(44, 26)
        Me.lblTradeOrg.TabIndex = 18
        Me.lblTradeOrg.Text = "Org"
        Me.lblTradeOrg.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblTradePerk
        '
        Me.lblTradePerk.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTradePerk.Location = New System.Drawing.Point(496, 4)
        Me.lblTradePerk.Name = "lblTradePerk"
        Me.lblTradePerk.Size = New System.Drawing.Size(44, 26)
        Me.lblTradePerk.TabIndex = 15
        Me.lblTradePerk.Text = "Perk"
        Me.lblTradePerk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblTradeIP
        '
        Me.lblTradeIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTradeIP.Location = New System.Drawing.Point(272, 4)
        Me.lblTradeIP.Name = "lblTradeIP"
        Me.lblTradeIP.Size = New System.Drawing.Size(44, 26)
        Me.lblTradeIP.TabIndex = 14
        Me.lblTradeIP.Text = "IP"
        Me.lblTradeIP.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblTradeImp
        '
        Me.lblTradeImp.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTradeImp.Location = New System.Drawing.Point(328, 4)
        Me.lblTradeImp.Name = "lblTradeImp"
        Me.lblTradeImp.Size = New System.Drawing.Size(44, 26)
        Me.lblTradeImp.TabIndex = 13
        Me.lblTradeImp.Text = "Imp"
        Me.lblTradeImp.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblTradeBuff
        '
        Me.lblTradeBuff.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTradeBuff.Location = New System.Drawing.Point(384, 4)
        Me.lblTradeBuff.Name = "lblTradeBuff"
        Me.lblTradeBuff.Size = New System.Drawing.Size(44, 26)
        Me.lblTradeBuff.TabIndex = 12
        Me.lblTradeBuff.Text = "Buff"
        Me.lblTradeBuff.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblTradeEquip
        '
        Me.lblTradeEquip.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTradeEquip.Location = New System.Drawing.Point(440, 4)
        Me.lblTradeEquip.Name = "lblTradeEquip"
        Me.lblTradeEquip.Size = New System.Drawing.Size(44, 26)
        Me.lblTradeEquip.TabIndex = 11
        Me.lblTradeEquip.Text = "Equip"
        Me.lblTradeEquip.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'tabSkills10
        '
        Me.tabSkills10.Controls.Add(Me.lblLegacyOrg)
        Me.tabSkills10.Controls.Add(Me.lblLegacyPerk)
        Me.tabSkills10.Controls.Add(Me.lblLegacyIP)
        Me.tabSkills10.Controls.Add(Me.lblLegacyImp)
        Me.tabSkills10.Controls.Add(Me.lblLegacyBuff)
        Me.tabSkills10.Controls.Add(Me.lblLegacyEquip)
        Me.tabSkills10.Location = New System.Drawing.Point(4, 23)
        Me.tabSkills10.Name = "tabSkills10"
        Me.tabSkills10.Size = New System.Drawing.Size(904, 429)
        Me.tabSkills10.TabIndex = 14
        Me.tabSkills10.Text = "Legacy"
        Me.tabSkills10.UseVisualStyleBackColor = True
        '
        'lblLegacyOrg
        '
        Me.lblLegacyOrg.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLegacyOrg.Location = New System.Drawing.Point(570, 4)
        Me.lblLegacyOrg.Name = "lblLegacyOrg"
        Me.lblLegacyOrg.Size = New System.Drawing.Size(44, 26)
        Me.lblLegacyOrg.TabIndex = 24
        Me.lblLegacyOrg.Text = "Org"
        Me.lblLegacyOrg.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblLegacyPerk
        '
        Me.lblLegacyPerk.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLegacyPerk.Location = New System.Drawing.Point(514, 4)
        Me.lblLegacyPerk.Name = "lblLegacyPerk"
        Me.lblLegacyPerk.Size = New System.Drawing.Size(44, 26)
        Me.lblLegacyPerk.TabIndex = 23
        Me.lblLegacyPerk.Text = "Perk"
        Me.lblLegacyPerk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblLegacyIP
        '
        Me.lblLegacyIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLegacyIP.Location = New System.Drawing.Point(290, 4)
        Me.lblLegacyIP.Name = "lblLegacyIP"
        Me.lblLegacyIP.Size = New System.Drawing.Size(44, 26)
        Me.lblLegacyIP.TabIndex = 22
        Me.lblLegacyIP.Text = "IP"
        Me.lblLegacyIP.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblLegacyImp
        '
        Me.lblLegacyImp.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLegacyImp.Location = New System.Drawing.Point(346, 4)
        Me.lblLegacyImp.Name = "lblLegacyImp"
        Me.lblLegacyImp.Size = New System.Drawing.Size(44, 26)
        Me.lblLegacyImp.TabIndex = 21
        Me.lblLegacyImp.Text = "Imp"
        Me.lblLegacyImp.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblLegacyBuff
        '
        Me.lblLegacyBuff.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLegacyBuff.Location = New System.Drawing.Point(402, 4)
        Me.lblLegacyBuff.Name = "lblLegacyBuff"
        Me.lblLegacyBuff.Size = New System.Drawing.Size(44, 26)
        Me.lblLegacyBuff.TabIndex = 20
        Me.lblLegacyBuff.Text = "Buff"
        Me.lblLegacyBuff.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblLegacyEquip
        '
        Me.lblLegacyEquip.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLegacyEquip.Location = New System.Drawing.Point(458, 4)
        Me.lblLegacyEquip.Name = "lblLegacyEquip"
        Me.lblLegacyEquip.Size = New System.Drawing.Size(44, 26)
        Me.lblLegacyEquip.TabIndex = 19
        Me.lblLegacyEquip.Text = "Equip"
        Me.lblLegacyEquip.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'tabPerks
        '
        Me.tabPerks.Controls.Add(Me.lblPerkPoints)
        Me.tabPerks.Controls.Add(Me.lblPerkList)
        Me.tabPerks.Controls.Add(Me.lstPerks)
        Me.tabPerks.Location = New System.Drawing.Point(4, 23)
        Me.tabPerks.Name = "tabPerks"
        Me.tabPerks.Size = New System.Drawing.Size(904, 429)
        Me.tabPerks.TabIndex = 10
        Me.tabPerks.Text = "Perks"
        '
        'lblPerkPoints
        '
        Me.lblPerkPoints.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblPerkPoints.Location = New System.Drawing.Point(108, 8)
        Me.lblPerkPoints.Name = "lblPerkPoints"
        Me.lblPerkPoints.Size = New System.Drawing.Size(84, 16)
        Me.lblPerkPoints.TabIndex = 2
        Me.lblPerkPoints.Text = ": 0/0"
        '
        'lblPerkList
        '
        Me.lblPerkList.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblPerkList.Location = New System.Drawing.Point(8, 8)
        Me.lblPerkList.Name = "lblPerkList"
        Me.lblPerkList.Size = New System.Drawing.Size(100, 16)
        Me.lblPerkList.TabIndex = 1
        Me.lblPerkList.Text = "Available Perks"
        '
        'lstPerks
        '
        Me.lstPerks.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lstPerks.ItemHeight = 15
        Me.lstPerks.Location = New System.Drawing.Point(8, 28)
        Me.lstPerks.Name = "lstPerks"
        Me.lstPerks.ScrollAlwaysVisible = True
        Me.lstPerks.Size = New System.Drawing.Size(320, 349)
        Me.lstPerks.TabIndex = 0
        '
        'tabAIPerks
        '
        Me.tabAIPerks.Controls.Add(Me.lblAIPerks)
        Me.tabAIPerks.Controls.Add(Me.Label67)
        Me.tabAIPerks.Controls.Add(Me.nudAlienTitle)
        Me.tabAIPerks.Controls.Add(Me.lstAIPerks)
        Me.tabAIPerks.Location = New System.Drawing.Point(4, 23)
        Me.tabAIPerks.Name = "tabAIPerks"
        Me.tabAIPerks.Size = New System.Drawing.Size(904, 429)
        Me.tabAIPerks.TabIndex = 11
        Me.tabAIPerks.Text = "AI Perks"
        '
        'lblAIPerks
        '
        Me.lblAIPerks.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblAIPerks.Location = New System.Drawing.Point(172, 8)
        Me.lblAIPerks.Name = "lblAIPerks"
        Me.lblAIPerks.Size = New System.Drawing.Size(56, 16)
        Me.lblAIPerks.TabIndex = 11
        Me.lblAIPerks.Text = "used 0"
        '
        'Label67
        '
        Me.Label67.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label67.Location = New System.Drawing.Point(8, 8)
        Me.Label67.Name = "Label67"
        Me.Label67.Size = New System.Drawing.Size(100, 16)
        Me.Label67.TabIndex = 10
        Me.Label67.Text = "Alien Title Level"
        '
        'nudAlienTitle
        '
        Me.nudAlienTitle.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudAlienTitle.Location = New System.Drawing.Point(112, 4)
        Me.nudAlienTitle.Maximum = New Decimal(New Integer() {30, 0, 0, 0})
        Me.nudAlienTitle.Name = "nudAlienTitle"
        Me.nudAlienTitle.Size = New System.Drawing.Size(56, 21)
        Me.nudAlienTitle.TabIndex = 9
        Me.nudAlienTitle.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'lstAIPerks
        '
        Me.lstAIPerks.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lstAIPerks.ItemHeight = 15
        Me.lstAIPerks.Location = New System.Drawing.Point(8, 28)
        Me.lstAIPerks.Name = "lstAIPerks"
        Me.lstAIPerks.ScrollAlwaysVisible = True
        Me.lstAIPerks.Size = New System.Drawing.Size(320, 349)
        Me.lstAIPerks.TabIndex = 8
        '
        'tabResearch
        '
        Me.tabResearch.Controls.Add(Me.lstResearch)
        Me.tabResearch.Location = New System.Drawing.Point(4, 23)
        Me.tabResearch.Name = "tabResearch"
        Me.tabResearch.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.tabResearch.Size = New System.Drawing.Size(904, 429)
        Me.tabResearch.TabIndex = 12
        Me.tabResearch.Text = "Research"
        '
        'lstResearch
        '
        Me.lstResearch.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lstResearch.ItemHeight = 15
        Me.lstResearch.Location = New System.Drawing.Point(8, 28)
        Me.lstResearch.Name = "lstResearch"
        Me.lstResearch.ScrollAlwaysVisible = True
        Me.lstResearch.Size = New System.Drawing.Size(320, 349)
        Me.lstResearch.TabIndex = 1
        '
        'tabOthers
        '
        Me.tabOthers.BackColor = System.Drawing.SystemColors.Control
        Me.tabOthers.Location = New System.Drawing.Point(4, 23)
        Me.tabOthers.Name = "tabOthers"
        Me.tabOthers.Size = New System.Drawing.Size(904, 429)
        Me.tabOthers.TabIndex = 13
        Me.tabOthers.Text = "Other Stats"
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miFile, Me.miEdit, Me.miLogging, Me.miBuffs, Me.miPerks, Me.miEquipment, Me.miOrgs, Me.miHelp})
        '
        'miFile
        '
        Me.miFile.Index = 0
        Me.miFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.meOpen, Me.meOpenRawData, Me.meSave, Me.meSaveAs, Me.mePrintPreview, Me.mePrint, Me.meExit})
        Me.miFile.Text = "&File"
        '
        'meOpen
        '
        Me.meOpen.Index = 0
        Me.meOpen.Text = "&Open..."
        '
        'meOpenRawData
        '
        Me.meOpenRawData.Index = 1
        Me.meOpenRawData.Text = "Open &Raw Data..."
        '
        'meSave
        '
        Me.meSave.Index = 2
        Me.meSave.Text = "&Save..."
        '
        'meSaveAs
        '
        Me.meSaveAs.Index = 3
        Me.meSaveAs.Text = "Save &As..."
        '
        'mePrintPreview
        '
        Me.mePrintPreview.Index = 4
        Me.mePrintPreview.Text = "Print Pre&view"
        '
        'mePrint
        '
        Me.mePrint.Index = 5
        Me.mePrint.Text = "&Print"
        '
        'meExit
        '
        Me.meExit.Index = 6
        Me.meExit.Text = "E&xit"
        '
        'miEdit
        '
        Me.miEdit.Index = 1
        Me.miEdit.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.meReset, Me.meMaxAttr})
        Me.miEdit.Text = "&Edit"
        '
        'meReset
        '
        Me.meReset.Index = 0
        Me.meReset.Text = "&Reset"
        '
        'meMaxAttr
        '
        Me.meMaxAttr.Index = 1
        Me.meMaxAttr.Text = "Max &Abilities"
        '
        'miLogging
        '
        Me.miLogging.Index = 2
        Me.miLogging.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.meLoggingToggle})
        Me.miLogging.Text = "Logging"
        '
        'meLoggingToggle
        '
        Me.meLoggingToggle.Index = 0
        Me.meLoggingToggle.Text = "Enable Logging"
        '
        'miBuffs
        '
        Me.miBuffs.Index = 3
        Me.miBuffs.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.meClearBuff, Me.MenuItem10, Me.meManageBuffs})
        Me.miBuffs.Text = "&Buffs"
        '
        'meClearBuff
        '
        Me.meClearBuff.Index = 0
        Me.meClearBuff.Text = "&Clear Buffs"
        '
        'MenuItem10
        '
        Me.MenuItem10.Index = 1
        Me.MenuItem10.Text = "-"
        '
        'meManageBuffs
        '
        Me.meManageBuffs.Index = 2
        Me.meManageBuffs.Text = "Manage Buffs"
        '
        'miPerks
        '
        Me.miPerks.Index = 4
        Me.miPerks.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.meClearPerks, Me.meLoadPerks, Me.meSavePerks})
        Me.miPerks.Text = "&Perks"
        '
        'meClearPerks
        '
        Me.meClearPerks.Index = 0
        Me.meClearPerks.Text = "&Clear Perks"
        '
        'meLoadPerks
        '
        Me.meLoadPerks.Index = 1
        Me.meLoadPerks.Text = "&Load Perks"
        '
        'meSavePerks
        '
        Me.meSavePerks.Index = 2
        Me.meSavePerks.Text = "&Save Perks"
        '
        'miEquipment
        '
        Me.miEquipment.Index = 5
        Me.miEquipment.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.meEquipConfig, Me.meImplantConfig})
        Me.miEquipment.Text = "E&quipment"
        '
        'meEquipConfig
        '
        Me.meEquipConfig.Index = 0
        Me.meEquipConfig.Text = "&Equipment Configurator"
        '
        'meImplantConfig
        '
        Me.meImplantConfig.Index = 1
        Me.meImplantConfig.Text = "Implant Configurator"
        '
        'miOrgs
        '
        Me.miOrgs.Index = 6
        Me.miOrgs.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.meClearMisc, Me.MenuItem13, Me.meManageMisc, Me.MenuItem14, Me.meLoadMisc, Me.meSaveMisc})
        Me.miOrgs.Text = "Org Benefits"
        '
        'meClearMisc
        '
        Me.meClearMisc.Index = 0
        Me.meClearMisc.Text = "Clear Benefits"
        '
        'MenuItem13
        '
        Me.MenuItem13.Index = 1
        Me.MenuItem13.Text = "-"
        '
        'meManageMisc
        '
        Me.meManageMisc.Index = 2
        Me.meManageMisc.Text = "Manage Benefits"
        '
        'MenuItem14
        '
        Me.MenuItem14.Index = 3
        Me.MenuItem14.Text = "-"
        '
        'meLoadMisc
        '
        Me.meLoadMisc.Index = 4
        Me.meLoadMisc.Text = "Load Benefits"
        '
        'meSaveMisc
        '
        Me.meSaveMisc.Index = 5
        Me.meSaveMisc.Text = "Save Benefits"
        '
        'miHelp
        '
        Me.miHelp.Index = 7
        Me.miHelp.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.meAbout, Me.MenuItem1, Me.meResetIH, Me.meResetBC})
        Me.miHelp.Text = "&Help"
        '
        'meAbout
        '
        Me.meAbout.Index = 0
        Me.meAbout.Text = "&About"
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 1
        Me.MenuItem1.Text = "-"
        '
        'meResetIH
        '
        Me.meResetIH.Index = 2
        Me.meResetIH.Text = "Reset Implant Helper Table"
        '
        'meResetBC
        '
        Me.meResetBC.Index = 3
        Me.meResetBC.Text = "Reset Buff Cache"
        '
        'fdOpen
        '
        Me.fdOpen.DefaultExt = "xml"
        Me.fdOpen.Filter = "XML Character File|*.xml"
        Me.fdOpen.InitialDirectory = "chars"
        Me.fdOpen.RestoreDirectory = True
        '
        'fdSave
        '
        Me.fdSave.DefaultExt = "xml"
        Me.fdSave.Filter = "XML Character File|*.xml"
        Me.fdSave.InitialDirectory = "chars"
        Me.fdSave.RestoreDirectory = True
        '
        'sePrintDocument
        '
        '
        'fdSaveBuff
        '
        Me.fdSaveBuff.DefaultExt = "buff"
        Me.fdSaveBuff.Filter = "Character Buff File|*.buff"
        Me.fdSaveBuff.InitialDirectory = "buffs"
        Me.fdSaveBuff.RestoreDirectory = True
        '
        'fdOpenImp
        '
        Me.fdOpenImp.DefaultExt = "imps"
        Me.fdOpenImp.Filter = "Character Implants File|*.imps"
        Me.fdOpenImp.InitialDirectory = "implants"
        Me.fdOpenImp.RestoreDirectory = True
        '
        'fdSaveImp
        '
        Me.fdSaveImp.DefaultExt = "imps"
        Me.fdSaveImp.Filter = "Character Implants File|*.imps"
        Me.fdSaveImp.InitialDirectory = "implants"
        Me.fdSaveImp.RestoreDirectory = True
        '
        'fdOpenEqu
        '
        Me.fdOpenEqu.DefaultExt = "equp"
        Me.fdOpenEqu.Filter = "Character Equipment File|*.equp"
        Me.fdOpenEqu.InitialDirectory = "equipment"
        Me.fdOpenEqu.RestoreDirectory = True
        '
        'fdSaveEqu
        '
        Me.fdSaveEqu.DefaultExt = "equp"
        Me.fdSaveEqu.Filter = "Character Equipment File|*.equp"
        Me.fdSaveEqu.InitialDirectory = "equipment"
        Me.fdSaveEqu.RestoreDirectory = True
        '
        'fdOpenPerk
        '
        Me.fdOpenPerk.DefaultExt = "perk"
        Me.fdOpenPerk.Filter = "Character Perk File|*.perk"
        Me.fdOpenPerk.InitialDirectory = "perks"
        Me.fdOpenPerk.RestoreDirectory = True
        '
        'fdSavePerk
        '
        Me.fdSavePerk.DefaultExt = "perk"
        Me.fdSavePerk.Filter = "Character Perk File|*.perk"
        Me.fdSavePerk.InitialDirectory = "perks"
        Me.fdSavePerk.RestoreDirectory = True
        '
        'fdOpenMisc
        '
        Me.fdOpenMisc.DefaultExt = "org"
        Me.fdOpenMisc.Filter = "Character Org Benefitc File|*.org"
        Me.fdOpenMisc.InitialDirectory = "org"
        Me.fdOpenMisc.RestoreDirectory = True
        '
        'fdSaveMisc
        '
        Me.fdSaveMisc.DefaultExt = "org"
        Me.fdSaveMisc.Filter = "Character Org Benefitc File|*.org"
        Me.fdSaveMisc.InitialDirectory = "org"
        Me.fdSaveMisc.RestoreDirectory = True
        '
        'sbInfo
        '
        Me.sbInfo.Location = New System.Drawing.Point(0, 502)
        Me.sbInfo.Name = "sbInfo"
        Me.sbInfo.Size = New System.Drawing.Size(932, 22)
        Me.sbInfo.TabIndex = 35
        '
        'fdOpenRawData
        '
        Me.fdOpenRawData.DefaultExt = "xml"
        Me.fdOpenRawData.Filter = "Raw Character Data|*.xml"
        Me.fdOpenRawData.InitialDirectory = "rawdata"
        Me.fdOpenRawData.RestoreDirectory = True
        '
        'FlowLayoutPanel1
        '
        Me.FlowLayoutPanel1.AutoSize = True
        Me.FlowLayoutPanel1.Controls.Add(Me.Label7)
        Me.FlowLayoutPanel1.Controls.Add(Me.nudLevel)
        Me.FlowLayoutPanel1.Controls.Add(Me.Label1)
        Me.FlowLayoutPanel1.Controls.Add(Me.cmbProf)
        Me.FlowLayoutPanel1.Controls.Add(Me.Label9)
        Me.FlowLayoutPanel1.Controls.Add(Me.cmbBreed)
        Me.FlowLayoutPanel1.Controls.Add(Me.Label12)
        Me.FlowLayoutPanel1.Controls.Add(Me.lblIP)
        Me.FlowLayoutPanel1.Location = New System.Drawing.Point(8, 2)
        Me.FlowLayoutPanel1.Name = "FlowLayoutPanel1"
        Me.FlowLayoutPanel1.Size = New System.Drawing.Size(802, 32)
        Me.FlowLayoutPanel1.TabIndex = 36
        '
        'Label7
        '
        Me.Label7.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label7.Location = New System.Drawing.Point(3, 0)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(40, 24)
        Me.Label7.TabIndex = 27
        Me.Label7.Text = "Level"
        Me.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'nudLevel
        '
        Me.nudLevel.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudLevel.Location = New System.Drawing.Point(49, 3)
        Me.nudLevel.Maximum = New Decimal(New Integer() {220, 0, 0, 0})
        Me.nudLevel.Minimum = New Decimal(New Integer() {1, 0, 0, 0})
        Me.nudLevel.Name = "nudLevel"
        Me.nudLevel.Size = New System.Drawing.Size(52, 21)
        Me.nudLevel.TabIndex = 28
        Me.nudLevel.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.nudLevel.Value = New Decimal(New Integer() {1, 0, 0, 0})
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(116, 0)
        Me.Label1.Margin = New System.Windows.Forms.Padding(12, 0, 3, 0)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(68, 24)
        Me.Label1.TabIndex = 30
        Me.Label1.Text = "Profession"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'cmbProf
        '
        Me.cmbProf.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbProf.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmbProf.Location = New System.Drawing.Point(190, 3)
        Me.cmbProf.MaxDropDownItems = 14
        Me.cmbProf.Name = "cmbProf"
        Me.cmbProf.Size = New System.Drawing.Size(152, 23)
        Me.cmbProf.TabIndex = 31
        '
        'Label9
        '
        Me.Label9.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label9.Location = New System.Drawing.Point(357, 0)
        Me.Label9.Margin = New System.Windows.Forms.Padding(12, 0, 3, 0)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(40, 24)
        Me.Label9.TabIndex = 32
        Me.Label9.Text = "Breed"
        Me.Label9.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'cmbBreed
        '
        Me.cmbBreed.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbBreed.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmbBreed.Location = New System.Drawing.Point(403, 3)
        Me.cmbBreed.Name = "cmbBreed"
        Me.cmbBreed.Size = New System.Drawing.Size(152, 23)
        Me.cmbBreed.TabIndex = 33
        '
        'Label12
        '
        Me.Label12.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label12.Location = New System.Drawing.Point(570, 0)
        Me.Label12.Margin = New System.Windows.Forms.Padding(12, 0, 3, 0)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(20, 24)
        Me.Label12.TabIndex = 34
        Me.Label12.Text = "IP"
        Me.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblIP
        '
        Me.lblIP.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblIP.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblIP.Location = New System.Drawing.Point(596, 3)
        Me.lblIP.Margin = New System.Windows.Forms.Padding(3)
        Me.lblIP.Name = "lblIP"
        Me.lblIP.Padding = New System.Windows.Forms.Padding(0, 1, 0, 1)
        Me.lblIP.Size = New System.Drawing.Size(136, 20)
        Me.lblIP.TabIndex = 35
        Me.lblIP.Text = "1500"
        Me.lblIP.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'frmMain
        '
        Me.AutoScaleDimensions = New System.Drawing.SizeF(96.0!, 96.0!)
        Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Dpi
        Me.ClientSize = New System.Drawing.Size(932, 524)
        Me.Controls.Add(Me.FlowLayoutPanel1)
        Me.Controls.Add(Me.sbInfo)
        Me.Controls.Add(Me.tabControls)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MaximumSize = New System.Drawing.Size(1298, 797)
        Me.Menu = Me.MainMenu1
        Me.Name = "frmMain"
        Me.tabControls.ResumeLayout(False)
        Me.tabAttr.ResumeLayout(False)
        Me.tabSkills1.ResumeLayout(False)
        Me.tabSkills2.ResumeLayout(False)
        Me.tabSkills3.ResumeLayout(False)
        Me.tabSkills4.ResumeLayout(False)
        Me.tabSkills5.ResumeLayout(False)
        Me.tabSkills6.ResumeLayout(False)
        Me.tabSkills7.ResumeLayout(False)
        Me.tabSkills8.ResumeLayout(False)
        Me.tabSkills9.ResumeLayout(False)
        Me.tabSkills10.ResumeLayout(False)
        Me.tabPerks.ResumeLayout(False)
        Me.tabAIPerks.ResumeLayout(False)
        CType(Me.nudAlienTitle, System.ComponentModel.ISupportInitialize).EndInit()
        Me.tabResearch.ResumeLayout(False)
        Me.FlowLayoutPanel1.ResumeLayout(False)
        CType(Me.nudLevel, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Private currentFile As String = ""

    Private lastLevel As Integer

    Private Sub SetPaths()
        Me.fdOpen.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "chars"
        Me.fdSave.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "chars"
        Me.fdSaveBuff.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "buffs"
        Me.fdOpenImp.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "implants"
        Me.fdSaveImp.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "implants"
        Me.fdOpenEqu.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "equipment"
        Me.fdSaveEqu.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "equipment"
        Me.fdOpenPerk.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "perks"
        Me.fdSavePerk.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "perks"
        Me.fdOpenMisc.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "org"
        Me.fdSaveMisc.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "org"
        Me.fdOpenRawData.InitialDirectory = home_dir & Path.DirectorySeparatorChar & "rawdata"
    End Sub

    Public Property BreedIndex() As Integer
        Get
            Return Me.cmbBreed.SelectedIndex
        End Get
        Set(ByVal Value As Integer)
            Me.cmbBreed.SelectedIndex = Value
        End Set
    End Property

    Public Property ProfIndex() As Integer
        Get
            Return Me.cmbProf.SelectedIndex
        End Get
        Set(ByVal Value As Integer)
            Me.cmbProf.SelectedIndex = Value
        End Set
    End Property

    Public Property NudLevelValue() As Integer
        Get
            Return CInt(Me.nudLevel.Value)
        End Get
        Set(ByVal Value As Integer)
            Me.nudLevel.Value = Value
        End Set
    End Property

    Public Property NudAlienTitleValue() As Integer
        Get
            Return CInt(Me.nudAlienTitle.Value)
        End Get
        Set(ByVal Value As Integer)
            Me.nudAlienTitle.Value = Value
        End Set
    End Property

    Public Property LblIPText() As String
        Get
            Return Me.lblIP.Text
        End Get
        Set(ByVal Value As String)
            Me.lblIP.Text = Value
        End Set
    End Property

    Private Sub SetupAOSControl(ByRef objCtrl As aosSkillAttrItem, ByVal top_pos As Integer)
        objCtrl.Height = 30
        objCtrl.Top = lblAbilitiesIP.Top + lblAbilitiesIP.Height + lblAbilitiesIP.Margin.Bottom + (top_pos * objCtrl.Height)
        objCtrl.Width = 720
        objCtrl.ChangeHandler = AddressOf aosHandler
        AddHandler objCtrl.doStatus, AddressOf showStatus
    End Sub

    Private Function SetupAttrs(ByRef objAttr As aosSkillAttrItem, ByVal idx As Integer) As Integer
        SetupAOSControl(objAttr, idx)
        objAttr.BaseValue = breedInit(0, idx)
        Return CInt(objAttr.Value)
    End Function

    Private Sub SetupSkills(ByRef objSkill As aosSkillAttrItem, ByVal top_pos As Integer, ByVal trickle As Integer)
        SetupAOSControl(objSkill, top_pos)
        objSkill.BaseValue = BASE_SKILL
        objSkill.TrickleDown = trickle
    End Sub

    Private Sub SetupAOSControl2(ByRef objCtrl2 As aosHPNPItem, ByVal top_pos As Integer, ByVal item_id As Integer)
        objCtrl2.Top = top_pos
        objCtrl2.Left = 4
        objCtrl2.Height = 30
        objCtrl2.Width = 624
        objCtrl2.ItemID = item_id
        objCtrl2.ChangeHandler = AddressOf aosHandler2
    End Sub

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer
        Dim el As aosSkillAttrItem
        Dim ab(NUM_ATTRS - 1) As Integer

        Dim skillTabPage() As System.Windows.Forms.TabPage = { _
           Me.tabSkills1, Me.tabSkills1, _
           Me.tabSkills2, Me.tabSkills3, Me.tabSkills3, Me.tabSkills3, Me.tabSkills7, Me.tabSkills10, _
           Me.tabSkills2, Me.tabSkills2, Me.tabSkills2, Me.tabSkills2, Me.tabSkills2,
           Me.tabSkills2, Me.tabSkills1, Me.tabSkills3, Me.tabSkills2, Me.tabSkills3, _
           Me.tabSkills5, Me.tabSkills4, Me.tabSkills4, _
           Me.tabSkills4, Me.tabSkills4, Me.tabSkills4, Me.tabSkills4, Me.tabSkills4, Me.tabSkills4, Me.tabSkills4,
           Me.tabSkills5, Me.tabSkills5, Me.tabSkills5, Me.tabSkills5, Me.tabSkills5, Me.tabSkills4, _
           Me.tabSkills2, Me.tabSkills4, Me.tabSkills2, Me.tabSkills6, Me.tabSkills1,
           Me.tabSkills1, Me.tabSkills1, Me.tabSkills1, Me.tabSkills7, _
           Me.tabSkills9, Me.tabSkills9, Me.tabSkills9, Me.tabSkills9, Me.tabSkills9,
           Me.tabSkills9, Me.tabSkills9, Me.tabSkills8, Me.tabSkills9, Me.tabSkills9, _
           Me.tabSkills6, Me.tabSkills6, Me.tabSkills6, Me.tabSkills6,
           Me.tabSkills6, Me.tabSkills6, Me.tabSkills8, Me.tabSkills8, _
           Me.tabSkills8, Me.tabSkills9, Me.tabSkills8, Me.tabSkills8, _
           Me.tabSkills7, Me.tabSkills7, Me.tabSkills7, Me.tabSkills10 _
        }
        ' skill control index offsets for y-coordinate calculation
        Dim skillYCoor() As Integer = { _
            0, 1,
            6, 1, 3, 4, 4, 0,
            0, 1, 2, 3, 4,
            5, 6, 0, 7, 2,
            5, 7, 8,
            1, 0, 3, 2, 4, 5, 6,
            0, 1, 2, 3, 4, 9,
            8, 10, 9, 6, 3,
            2, 4, 5, 3,
            0, 1, 2, 4, 9,
            5, 8, 2, 3, 6,
            0, 1, 2, 5,
            4, 3, 4, 5,
            1, 7, 3, 0,
            0, 1, 2, 1
        }
        '
        Me.Text = My.Application.Info.Title
        '
        Me.cmbProf.Items.Clear()
        For i = 0 To NUM_PROFS - 1
            Me.cmbProf.Items.Add(profNames(i))
        Next
        Me.cmbBreed.Items.Clear()
        For i = 0 To NUM_BREEDS - 1
            Me.cmbBreed.Items.Add(breedNames(i))
        Next
        '
        Dim ssAOS3 As New aosSplashScreen
        ssAOS3.Show()
        ssAOS3.Refresh()
        fmImplant.initFrmImplants()
        ' Abilities
        attrCA = New aosSkillAttrItemArray
        For i = 0 To NUM_ATTRS - 1
            el = attrCA.AddNewNUD(Me.tabAttr, attrNames(i), i)
            ab(i) = SetupAttrs(el, i)
        Next
        ' Skills
        skillsCA = New aosSkillAttrItemArray
        For i = 0 To NUM_SKILLS - 1
            el = skillsCA.AddNewNUD(skillTabPage(i), skillNames(i), 100 + i)
            SetupSkills(el, skillYCoor(i), calcTrickleDown(ab, i))
        Next
        ' Hit Points
        hpCA = New aosHPNPItem
        Me.tabAttr.Controls.Add(hpCA)
        hpCA.ControlTabPage = Me.tabAttr
        SetupAOSControl2(hpCA, 246, 200)
        hpCA.ItemName = "Hit Points"
        hpCA.BaseValue = breedBaseHP(0)
        ' Nano Points
        npCA = New aosHPNPItem
        Me.tabAttr.Controls.Add(npCA)
        SetupAOSControl2(npCA, 278, 201)
        npCA.ControlTabPage = Me.tabAttr
        npCA.ItemName = "Nano Points"
        npCA.BaseValue = breedBaseNP(0)
        ' Other Init Stuff
        noRecalc = True
        Me.cmbProf.SelectedIndex = 0
        Me.cmbBreed.SelectedIndex = 0
        Me.nudAlienTitle.Value = 0
        noRecalc = False
        ' set up other stats here
        setupOtherStats(Me.tabOthers)
        ' do scale checking and stuff here...
        handleDPIScaling()
        ' create perks
        perkCA = New aosPerkCheckboxArray("SL", Me.tabPerks)
        aiperkCA = New aosPerkCheckboxArray("AI", Me.tabAIPerks)
        leperkCA = New aosPerkCheckboxArray("LE", Me.tabResearch)
        ' ensure equipment and buffs are initialised
        noRecalc = True
        ResetEquipment()
        fmBuff.Reset()
        noRecalc = False
        '
        initApp = False
        recalcIP()
        '
        Me.Top = form_positions(FORM_MAIN, FORM_TOP)
        Me.Left = form_positions(FORM_MAIN, FORM_LEFT)
        Me.Height = form_positions(FORM_MAIN, FORM_HEIGHT)
        Me.Width = form_positions(FORM_MAIN, FORM_WIDTH)
        ssAOS3.Hide()
        hasChanges = False
        '
    End Sub

    ' we changed level, recalculate abilities and skills
    Private Sub nudLevel_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudLevel.ValueChanged
        Dim i As Integer
        Dim old_noRecalc As Boolean

        If lastLevel > CInt(Me.nudLevel.Value) Then
            If Not fmMain Is Nothing Then
                For i = 0 To SLPerks.Count - 1
                    If SLPerks(i).Selected = True Then
                        If SLPerks(i).Level > Me.nudLevel.Value Then
                            RemPerk(SLPerks, i)
                        End If
                    End If
                Next
                For i = 0 To AIPerks.Count - 1
                    If AIPerks(i).Selected = True Then
                        If AIPerks(i).Level > Me.nudLevel.Value Then
                            RemPerk(AIPerks, i)
                        End If
                    End If
                Next
                For i = 0 To LEPerks.Count - 1
                    If LEPerks(i).Selected = True Then
                        If LEPerks(i).Level > Me.nudLevel.Value Then
                            RemPerk(LEPerks, i)
                        End If
                    End If
                Next
            End If
        End If
        If Not fmMain Is Nothing Then
            old_noRecalc = noRecalc
            noRecalc = True
            UpdateCheckboxes(fmMain.lstPerks, perkCA, SLPerks)
            UpdateCheckboxes(fmMain.lstAIPerks, aiperkCA, AIPerks)
            UpdateCheckboxes(fmMain.lstResearch, leperkCA, LEPerks)
            setMaxAlienTitle(CInt(Me.nudLevel.Value))
            updatePerks()
            fmBene.ProcessAllBenefits()
            noRecalc = old_noRecalc
            recalcIP()
        End If
        lastLevel = CInt(Me.nudLevel.Value)
        hasChanges = True
    End Sub

    Private Sub nudLevel_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles nudLevel.Enter
        lastLevel = CInt(Me.nudLevel.Value)
    End Sub

    Private Sub nudLevel_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles nudLevel.Leave
        If lastLevel <> CInt(Me.nudLevel.Value) Then
            nudLevel_ValueChanged(sender, e)
            'updatePerks()
            'recalcIP()
            If Not IsNothing(fmMain.LoggingHandle) Then
                fmMain.LoggingHandle.LogLevel(lastLevel, CInt(Me.nudLevel.Value))
            End If
        End If
    End Sub

    ' we changed profession, recalculate abilities and skills
    Private Sub cmbProf_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbProf.SelectedIndexChanged
        Dim i As Integer
        Dim pl As String()
        Dim old_noRecalc As Boolean

        old_noRecalc = noRecalc
        noRecalc = True
        For i = 0 To NUM_ATTRS - 1
            attrCA.Item(i).ProfID = Me.cmbProf.SelectedIndex
        Next
        For i = 0 To NUM_SKILLS - 1
            skillsCA.Item(i).ProfID = Me.cmbProf.SelectedIndex
        Next
        If loadingData = False Then
            ClearPerks()
        End If
        Me.lstPerks.Items.Clear()
        Me.lstAIPerks.Items.Clear()
        Me.lstResearch.Items.Clear()
        pl = GetPerksByProfAndBreed(SLPerks, Me.cmbProf.SelectedIndex, Me.cmbBreed.SelectedIndex)
        Array.Sort(pl)
        For i = 0 To UBound(pl)
            Me.lstPerks.Items.Add(pl(i))
        Next
        UpdateCheckboxes(fmMain.lstPerks, perkCA, SLPerks)
        pl = GetPerksByProfAndBreed(AIPerks, Me.cmbProf.SelectedIndex, Me.cmbBreed.SelectedIndex)
        Array.Sort(pl)
        For i = 0 To UBound(pl)
            Me.lstAIPerks.Items.Add(pl(i))
        Next
        UpdateCheckboxes(fmMain.lstAIPerks, aiperkCA, AIPerks)
        pl = GetPerksByProfAndBreed(LEPerks, Me.cmbProf.SelectedIndex, Me.cmbBreed.SelectedIndex)
        Array.Sort(pl)
        For i = 0 To UBound(pl)
            Me.lstResearch.Items.Add(pl(i))
        Next
        UpdateCheckboxes(fmMain.lstResearch, leperkCA, LEPerks)
        Me.Cursor = Cursors.WaitCursor
        If impA.Count > 0 Then
            For i = 0 To MAX_IMPS
                ' reset implant object the set the profession
                impA(i).Reset()
                impA(i).ProfessionID = cmbProf.SelectedIndex
            Next
        End If
        ' reset buffs and equipment (as those can be profession specific) 
        ' no need to reset org benefits though as those are generic
        ' don't do when initialising!
        If Not initAppNain Then
            fmBuff.Reset()
            fmPDoll.Reset()
        End If
        Me.Cursor = Cursors.Arrow
        noRecalc = old_noRecalc
        If Not fmMain Is Nothing Then
            recalcIP()
        End If
        hasChanges = True
    End Sub

    ' we changed breed, recalculate abilities and skills
    Private Sub cmbBreed_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbBreed.SelectedIndexChanged
        Dim i As Integer
        Dim pl As String()
        Dim old_noRecalc As Boolean

        old_noRecalc = noRecalc
        noRecalc = True
        For i = 0 To NUM_ATTRS - 1
            attrCA.Item(i).BaseValue = breedInit(Me.cmbBreed.SelectedIndex, i)
            attrCA.Item(i).BreedID = Me.cmbBreed.SelectedIndex
        Next
        For i = 0 To NUM_SKILLS - 1
            skillsCA.Item(i).BreedID = Me.cmbBreed.SelectedIndex
        Next
        If loadingData = False Then
            ClearPerks()
        End If
        Me.lstPerks.Items.Clear()
        Me.lstAIPerks.Items.Clear()
        Me.lstResearch.Items.Clear()
        pl = GetPerksByProfAndBreed(SLPerks, Me.cmbProf.SelectedIndex, Me.cmbBreed.SelectedIndex)
        Array.Sort(pl)
        For i = 0 To UBound(pl)
            Me.lstPerks.Items.Add(pl(i))
        Next
        UpdateCheckboxes(fmMain.lstPerks, perkCA, SLPerks)
        pl = GetPerksByProfAndBreed(AIPerks, Me.cmbProf.SelectedIndex, Me.cmbBreed.SelectedIndex)
        Array.Sort(pl)
        For i = 0 To UBound(pl)
            Me.lstAIPerks.Items.Add(pl(i))
        Next
        UpdateCheckboxes(fmMain.lstAIPerks, aiperkCA, AIPerks)
        pl = GetPerksByProfAndBreed(LEPerks, Me.cmbProf.SelectedIndex, Me.cmbBreed.SelectedIndex)
        Array.Sort(pl)
        For i = 0 To UBound(pl)
            Me.lstResearch.Items.Add(pl(i))
        Next
        UpdateCheckboxes(fmMain.lstResearch, leperkCA, LEPerks)
        Me.Cursor = Cursors.WaitCursor
        If impA.Count > 0 Then
            For i = 0 To MAX_IMPS
                impA(i).BreedID = cmbBreed.SelectedIndex
            Next
        End If
        Me.Cursor = Cursors.Arrow
        noRecalc = old_noRecalc
        If Not fmMain Is Nothing Then
            recalcIP()
        End If
        hasChanges = True
    End Sub

    ' external handler for ability/skill controls
    Private Sub aosHandler(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If Not fmMain Is Nothing Then
            recalcIP()
        End If
    End Sub

    ' dummy handler for hp/nano controls
    Private Sub aosHandler2(ByVal sender As System.Object, ByVal e As System.EventArgs)
    End Sub

    ' File/Open menu item
    Private Sub meOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meOpen.Click
        Dim result As System.Windows.Forms.DialogResult

        If CheckAbortExit() Then
            Return
        End If
        result = Me.fdOpen.ShowDialog(Me)
        If result = DialogResult.OK Then
            ' if logging, then turn it off before loading new character
            If Not IsNothing(fmMain.LoggingHandle) Then
                Me.meLoggingToggle.Checked = False
                LoggingHandle.Close()
                LoggingHandle = Nothing
            End If
            currentFile = fdOpen.FileName
            loadDataNew(currentFile)
            Me.Text = My.Application.Info.Title & " : " & currentFile
            hasChanges = False
        End If
    End Sub

    ' File/Save menu item
    Private Sub meSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meSave.Click
        If Len(currentFile) = 0 Then
            meSaveAs_Click(sender, e)
        Else
            saveDataNew(currentFile)
            hasChanges = False
        End If
    End Sub

    ' File/Save As menu item
    Private Sub meSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meSaveAs.Click
        Dim result As System.Windows.Forms.DialogResult

        result = Me.fdSave.ShowDialog(Me)
        If result = DialogResult.OK Then
            ' if logging, then turn it off before saving character with new name
            If Not IsNothing(fmMain.LoggingHandle) Then
                Me.meLoggingToggle.Checked = False
                LoggingHandle.Close()
                LoggingHandle = Nothing
            End If
            currentFile = fdSave.FileName
            saveDataNew(currentFile)
            Me.Text = My.Application.Info.Title & " : " & currentFile
            hasChanges = False
        End If
    End Sub

    ' File/Print Preview menu item
    Private Sub mePrintPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mePrintPreview.Click
        Dim ppd As New PrintPreviewDialog
        Dim sps As New PageSettings

        sps.Margins.Top = 50
        sps.Margins.Bottom = 50
        sps.Margins.Left = 50
        sps.Margins.Right = 50
        Me.sePrintDocument.DefaultPageSettings = sps
        ppd.Document = Me.sePrintDocument
        ppd.ShowDialog()
    End Sub

    ' File/Print menu item
    Private Sub mePrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mePrint.Click
        Dim dlg As New PrintDialog
        Dim sps As New PageSettings

        sps.Margins.Top = 50
        sps.Margins.Bottom = 50
        sps.Margins.Left = 50
        sps.Margins.Right = 50
        Me.sePrintDocument.DefaultPageSettings = sps
        dlg.Document = Me.sePrintDocument
        Dim result As DialogResult = dlg.ShowDialog()
        If (result = System.Windows.Forms.DialogResult.OK) Then
            Me.sePrintDocument.Print()
        End If
    End Sub

    ' File/Exit menu item
    Private Sub meExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meExit.Click
        ' FormClosing even handles this? seems not...
        ' check if hasChanges is true and ask if user is sure as they have unsaved changes?
        If CheckAbortExit() Then
            Return
        End If
        SaveWindowData()
        End
    End Sub

    ' Edit/Reset menu item
    Private Sub meReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meReset.Click
        If CheckAbortExit() Then
            Return
        End If
        ResetChar()
    End Sub

    ' Edit/Max Abilities menu item
    Private Sub meMaxAttr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meMaxAttr.Click
        Dim i As Integer

        noRecalc = True
        For i = 0 To NUM_ATTRS - 1
            attrCA.Item(i).Improvement = attrCA.Item(i).MaxImprove
        Next
        noRecalc = False
        recalcIP()
    End Sub

    ' Edit/Clear Buffs menu item
    Private Sub meClearBuff_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meClearBuff.Click
        fmBuff.Reset()
    End Sub

    ' Edit/Clear Perks menu item
    Private Sub meClearPerks_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meClearPerks.Click
        ClearPerks()
        UpdateCheckboxes(fmMain.lstPerks, perkCA, SLPerks)
        UpdateCheckboxes(fmMain.lstAIPerks, aiperkCA, AIPerks)
        UpdateCheckboxes(fmMain.lstResearch, leperkCA, LEPerks)
    End Sub

    ' Edit/Clear Misc menu item
    Private Sub meClearMisc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meClearMisc.Click
        fmBene.Reset()
    End Sub

    ' Help/About menu item
    Private Sub meAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meAbout.Click
        MsgBox(My.Application.Info.Title & Chr(13) & My.Application.Info.Copyright, CType(MsgBoxStyle.Information + MsgBoxStyle.OkOnly, Microsoft.VisualBasic.MsgBoxStyle), "About...")
    End Sub

    ' document print routine
    Private Sub sePrintDocument_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles sePrintDocument.PrintPage
        Dim drawFontH As New Font("Arial", 10)
        Dim drawFont As New Font("Courier New", 8)
        Dim yPos As Double = 0
        Dim i As Integer

        yPos = e.MarginBounds.Top
        printLine("Character Sheet", drawFontH, yPos, e)
        printLine("", drawFont, yPos, e)
        printLine("Breed: " & breedNames(Me.cmbBreed.SelectedIndex), drawFont, yPos, e)
        printLine("Profession: " & profNames(Me.cmbProf.SelectedIndex) & " (Level " & CStr(Me.nudLevel.Value) & ")", drawFont, yPos, e)
        printLine("", drawFont, yPos, e)
        For i = 0 To NUM_ATTRS - 1
            printLine(fixWidth(attrNames(i), 16, True) & ": " & formatItem(attrCA.Item(i)), drawFont, yPos, e)
        Next
        printLine("", drawFont, yPos, e)
        For i = 0 To NUM_SKILLS - 1
            printLine(fixWidth(skillNames(i), 16, True) & ": " & formatItem(skillsCA.Item(i)), drawFont, yPos, e)
        Next
        printLine("", drawFont, yPos, e)
        printLine("Hit Points      : " & formatItem2(hpCA), drawFont, yPos, e)
        printLine("Nano Points     : " & formatItem2(npCA), drawFont, yPos, e)
    End Sub

    ' print a line and adjust draw position
    Private Sub printLine(ByRef line As String, ByRef fnt As Font, ByRef yPos As Double, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
        e.Graphics.DrawString(line, fnt, Brushes.Black, e.MarginBounds.Left, CSng(yPos), New StringFormat)
        yPos = yPos + fnt.GetHeight(e.Graphics)
    End Sub

    ' print format routine for abilities and skills
    Private Function formatItem(ByVal itm As aosSkillAttrItem) As String
        Dim item_string As String = ""

        item_string = fixWidth(CStr(itm.Value), 4)
        item_string = item_string & "  (Base: " & fixWidth(CStr(itm.Unbuffed), 4)
        item_string = item_string & " | Implant: " & fixWidth(CStr(itm.Implant), 4)
        item_string = item_string & " | Buff: " & fixWidth(CStr(itm.Buff), 4)
        item_string = item_string & " | Equip: " & fixWidth(CStr(itm.Other), 4)
        item_string = item_string & " | Perk: " & fixWidth(CStr(itm.Perk), 4) & ")"
        item_string = item_string & " | Org: " & fixWidth(CStr(itm.Misc), 4) & ")"
        Return item_string
    End Function

    ' print format routine for hp/np
    Private Function formatItem2(ByVal itm As aosHPNPItem) As String
        Dim item_string As String = ""

        item_string = fixWidth(CStr(itm.Value), 4)
        item_string = item_string & "  (Base: " & fixWidth(CStr(itm.BaseValue), 4)
        item_string = item_string & " | Implant: " & fixWidth(CStr(itm.Implant), 4)
        item_string = item_string & " | Buff: " & fixWidth(CStr(itm.Buff), 4)
        item_string = item_string & " | Equip: " & fixWidth(CStr(itm.Other), 4)
        item_string = item_string & " | Perk: " & fixWidth(CStr(itm.Perk), 4) & ")"
        item_string = item_string & " | Org: " & fixWidth(CStr(itm.Misc), 4) & ")"
        Return item_string
    End Function

    ' simple format routine to ensure a string is a certain size by trimming or space padding
    Function fixWidth(ByVal s As String, ByVal w As Integer, Optional ByVal before As Boolean = False) As String
        If s.Length > w Then
            Return s.Substring(0, w)
        End If
        If before = True Then
            Return s & Space(w).Substring(0, w - s.Length)
        End If
        Return Space(w).Substring(0, w - s.Length) & s
    End Function

    ' Delegate subroutine for updating status bar on mouse over
    Sub showStatus(ByVal id As Integer)
        Dim sb_value As String = ""
        Dim i As Integer
        Dim flg As Boolean = False

        If id = -1 Then ' used to clear status bar on exit from a control
            sb_value = ""
        Else
            If id < 100 Then
                ' it's an ability
                sb_value = attrCA.Item(id).ItemName & ": " & CStr(attrCA.Item(id).nudBasicSkill.Minimum) & " to " & CStr(attrCA.Item(id).nudBasicSkill.Maximum)
            Else
                ' it's a skill
                sb_value = skillsCA.Item(id - 100).ItemName & ": " & CStr(skillsCA.Item(id - 100).nudBasicSkill.Minimum) & " to " & CStr(skillsCA.Item(id - 100).nudBasicSkill.Maximum)
                sb_value = sb_value & ", currently " & CStr(skillsCA.Item(id - 100).Unbuffed) & " (" & CStr(skillsCA.Item(id - 100).BaseValue + skillsCA.Item(id - 100).TrickleDown) & " Base + " & CStr(skillsCA.Item(id - 100).Improvement) & " From IP)  "
                ' show controlling abilities and their percentage
                For i = 0 To NUM_ATTRS - 1
                    If skillAbilities(id - 100, i) > 0 Then
                        If flg = True Then
                            sb_value = sb_value & ", "
                        End If
                        sb_value = sb_value & attrNames(i) & ": " & CStr(skillAbilities(id - 100, i) * 100) & "%"
                        flg = True
                    End If
                Next
            End If
        End If
        Me.sbInfo.Text = sb_value
    End Sub

    Private Sub meLoadPerks_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meLoadPerks.Click
        Dim result As System.Windows.Forms.DialogResult
        Dim dFile As String

        result = Me.fdOpenPerk.ShowDialog(Me)
        If result = DialogResult.OK Then
            dFile = fdOpenPerk.FileName
            loadData_Perk(dFile)
            UpdateCheckboxes(fmMain.lstPerks, perkCA, SLPerks)
            UpdateCheckboxes(fmMain.lstAIPerks, aiperkCA, AIPerks)
            UpdateCheckboxes(fmMain.lstResearch, leperkCA, LEPerks)
        End If
    End Sub

    Private Sub meLoadMisc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meLoadMisc.Click
        Dim result As System.Windows.Forms.DialogResult
        Dim dFile As String

        result = Me.fdOpenMisc.ShowDialog(Me)
        If result = DialogResult.OK Then
            dFile = fdOpenMisc.FileName
            loadData_Misc(dFile)
        End If
    End Sub

    Private Sub meSavePerks_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meSavePerks.Click
        Dim result As System.Windows.Forms.DialogResult
        Dim dFile As String

        result = Me.fdSavePerk.ShowDialog(Me)
        If result = DialogResult.OK Then
            dFile = fdSavePerk.FileName
            saveData_Perk(dFile)
        End If
    End Sub

    Private Sub meSaveMisc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meSaveMisc.Click
        Dim result As System.Windows.Forms.DialogResult
        Dim dFile As String

        result = Me.fdSaveMisc.ShowDialog(Me)
        If result = DialogResult.OK Then
            dFile = fdSaveMisc.FileName
            saveData_Misc(dFile)
        End If
    End Sub

    Private Sub lstPerks_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstPerks.SelectedIndexChanged
        UpdateCheckboxes(fmMain.lstPerks, perkCA, SLPerks)
    End Sub

    Public Sub updatePerks()
        Me.lblPerkPoints.Text = ": " & CStr(CountAllSelectedPerks(SLPerks)) & "/" & CStr(GetNumberOfSLPerks(CInt(Me.nudLevel.Value)))
        Me.lblAIPerks.Text = "used " & CStr(CountAllSelectedPerks(AIPerks))
    End Sub

    Private Sub lstAIPerks_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstAIPerks.SelectedIndexChanged
        UpdateCheckboxes(fmMain.lstAIPerks, aiperkCA, AIPerks)
    End Sub

    Private Sub nudAlienTitle_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudAlienTitle.ValueChanged
        Dim i As Integer
        If Not fmMain Is Nothing Then
            For i = 0 To AIPerks.Count - 1
                If AIPerks(i).Selected = True Then
                    If AIPerks(i).Level > Me.nudLevel.Value Then
                        RemPerk(AIPerks, i)
                    End If
                End If
            Next
            UpdateCheckboxes(fmMain.lstResearch, leperkCA, LEPerks)
            UpdateCheckboxes(fmMain.lstAIPerks, aiperkCA, AIPerks)
            recalcIP()
        End If
    End Sub

    Private Sub lstResearch_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstResearch.SelectedIndexChanged
        UpdateCheckboxes(fmMain.lstResearch, leperkCA, LEPerks)
    End Sub

    Private Sub meEquipConfig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meEquipConfig.Click
        fmPDoll.Show()
    End Sub

    Private Sub meImplantConfig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meImplantConfig.Click
        ' open implant window
        fmImplant.Show()
    End Sub

    Private Sub meManageBuffs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meManageBuffs.Click
        fmBuff.Show(Me)
    End Sub

    Private Sub meManageMisc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meManageMisc.Click
        fmBene.Show(Me)
    End Sub

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.FormClosing
        ' check if hasChanges is true and ask if user is sure as they have unsaved changes?
        If CheckAbortExit() Then
            e.Cancel = True
        End If
        SaveWindowData()
    End Sub

    Private Sub frmMain_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Me.tabControls.Height = Me.Height - 114
        Me.tabControls.Width = Me.Width - 24
    End Sub

    ' Open Raw Data menu item
    Private Sub meOpenRawData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meOpenRawData.Click
        Dim result As System.Windows.Forms.DialogResult

        If CheckAbortExit() Then
            Return
        End If
        result = Me.fdOpenRawData.ShowDialog(Me)
        If result = DialogResult.OK Then
            currentFile = fdOpenRawData.FileName
            loadRawData(currentFile)
            hasChanges = False
        End If
    End Sub

    Private Sub meLoggingToggle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles meLoggingToggle.Click
        Dim strCharName As String

        If Me.meLoggingToggle.Checked Then
            Me.meLoggingToggle.Checked = False
            LoggingHandle.Close()
            LoggingHandle = Nothing
        Else
            Me.meLoggingToggle.Checked = True
            If Me.Text.IndexOf(" : ", StringComparison.Ordinal) = -1 Then
                strCharName = "unknown"
            Else
                strCharName = Me.Text.Substring(Me.Text.IndexOf(" : ", StringComparison.Ordinal) + 3)
                strCharName = System.IO.Path.GetFileName(strCharName)
                strCharName = strCharName.Replace(".xml", "")
            End If
            LoggingHandle = New ActionLogger(strCharName, CInt(Me.nudLevel.Value))
        End If
    End Sub

    Private Sub handleDPIScaling()
        ' do scale checking and stuff here...
        lblAbilitiesIP.Left = attrCA(0).nudBasicSkill.Left + attrCA(0).Left
        lblAbilitiesImp.Left = attrCA(0).nudImplant.Left + attrCA(0).Left
        lblAbilitiesBuff.Left = attrCA(0).nudBuff.Left + attrCA(0).Left
        lblAbilitiesEquip.Left = attrCA(0).nudOther.Left + attrCA(0).Left
        lblAbilitiesPerk.Left = attrCA(0).nudPerk.Left + attrCA(0).Left
        lblAbilitiesOrg.Left = attrCA(0).nudMisc.Left + attrCA(0).Left
        '
        lblBodyIP.Left = attrCA(0).nudBasicSkill.Left + attrCA(0).Left
        lblBodyImp.Left = attrCA(0).nudImplant.Left + attrCA(0).Left
        lblBodyBuff.Left = attrCA(0).nudBuff.Left + attrCA(0).Left
        lblBodyEquip.Left = attrCA(0).nudOther.Left + attrCA(0).Left
        lblBodyPerk.Left = attrCA(0).nudPerk.Left + attrCA(0).Left
        lblBodyOrg.Left = attrCA(0).nudMisc.Left + attrCA(0).Left
        '
        lblMeleeIP.Left = attrCA(0).nudBasicSkill.Left + attrCA(0).Left
        lblMeleeImp.Left = attrCA(0).nudImplant.Left + attrCA(0).Left
        lblMeleeBuff.Left = attrCA(0).nudBuff.Left + attrCA(0).Left
        lblMeleeEquip.Left = attrCA(0).nudOther.Left + attrCA(0).Left
        lblMeleePerk.Left = attrCA(0).nudPerk.Left + attrCA(0).Left
        lblMeleeOrg.Left = attrCA(0).nudMisc.Left + attrCA(0).Left
        '
        lblMeleeSpecIP.Left = attrCA(0).nudBasicSkill.Left + attrCA(0).Left
        lblMeleeSpecImp.Left = attrCA(0).nudImplant.Left + attrCA(0).Left
        lblMeleeSpecBuff.Left = attrCA(0).nudBuff.Left + attrCA(0).Left
        lblMeleeSpecEquip.Left = attrCA(0).nudOther.Left + attrCA(0).Left
        lblMeleeSpecPerk.Left = attrCA(0).nudPerk.Left + attrCA(0).Left
        lblMeleeSpecOrg.Left = attrCA(0).nudMisc.Left + attrCA(0).Left
        '
        lblRangedIP.Left = attrCA(0).nudBasicSkill.Left + attrCA(0).Left
        lblRangedImp.Left = attrCA(0).nudImplant.Left + attrCA(0).Left
        lblRangedBuff.Left = attrCA(0).nudBuff.Left + attrCA(0).Left
        lblRangedEquip.Left = attrCA(0).nudOther.Left + attrCA(0).Left
        lblRangedPerk.Left = attrCA(0).nudPerk.Left + attrCA(0).Left
        lblRangedOrg.Left = attrCA(0).nudMisc.Left + attrCA(0).Left
        '
        lblRangeSpecIP.Left = attrCA(0).nudBasicSkill.Left + attrCA(0).Left
        lblRangeSpecImp.Left = attrCA(0).nudImplant.Left + attrCA(0).Left
        lblRangeSpecBuff.Left = attrCA(0).nudBuff.Left + attrCA(0).Left
        lblRangeSpecEquip.Left = attrCA(0).nudOther.Left + attrCA(0).Left
        lblRangeSpecPerk.Left = attrCA(0).nudPerk.Left + attrCA(0).Left
        lblRangeSpecOrg.Left = attrCA(0).nudMisc.Left + attrCA(0).Left
        '
        lblNanoIP.Left = attrCA(0).nudBasicSkill.Left + attrCA(0).Left
        lblNanoImp.Left = attrCA(0).nudImplant.Left + attrCA(0).Left
        lblNanoBuff.Left = attrCA(0).nudBuff.Left + attrCA(0).Left
        lblNanoEquip.Left = attrCA(0).nudOther.Left + attrCA(0).Left
        lblNanoPerk.Left = attrCA(0).nudPerk.Left + attrCA(0).Left
        lblNanoOrg.Left = attrCA(0).nudMisc.Left + attrCA(0).Left
        '
        lblExploreIP.Left = attrCA(0).nudBasicSkill.Left + attrCA(0).Left
        lblExploreImp.Left = attrCA(0).nudImplant.Left + attrCA(0).Left
        lblExploreBuff.Left = attrCA(0).nudBuff.Left + attrCA(0).Left
        lblExploreEquip.Left = attrCA(0).nudOther.Left + attrCA(0).Left
        lblExplorePerk.Left = attrCA(0).nudPerk.Left + attrCA(0).Left
        lblExploreOrg.Left = attrCA(0).nudMisc.Left + attrCA(0).Left
        '
        lblCombatIP.Left = attrCA(0).nudBasicSkill.Left + attrCA(0).Left
        lblCombatImp.Left = attrCA(0).nudImplant.Left + attrCA(0).Left
        lblCombatBuff.Left = attrCA(0).nudBuff.Left + attrCA(0).Left
        lblCombatEquip.Left = attrCA(0).nudOther.Left + attrCA(0).Left
        lblCombatPerk.Left = attrCA(0).nudPerk.Left + attrCA(0).Left
        lblCombatOrg.Left = attrCA(0).nudMisc.Left + attrCA(0).Left
        '
        lblTradeIP.Left = attrCA(0).nudBasicSkill.Left + attrCA(0).Left
        lblTradeImp.Left = attrCA(0).nudImplant.Left + attrCA(0).Left
        lblTradeBuff.Left = attrCA(0).nudBuff.Left + attrCA(0).Left
        lblTradeEquip.Left = attrCA(0).nudOther.Left + attrCA(0).Left
        lblTradePerk.Left = attrCA(0).nudPerk.Left + attrCA(0).Left
        lblTradeOrg.Left = attrCA(0).nudMisc.Left + attrCA(0).Left
        '
        lblLegacyIP.Left = attrCA(0).nudBasicSkill.Left + attrCA(0).Left
        lblLegacyImp.Left = attrCA(0).nudImplant.Left + attrCA(0).Left
        lblLegacyBuff.Left = attrCA(0).nudBuff.Left + attrCA(0).Left
        lblLegacyEquip.Left = attrCA(0).nudOther.Left + attrCA(0).Left
        lblLegacyPerk.Left = attrCA(0).nudPerk.Left + attrCA(0).Left
        lblLegacyOrg.Left = attrCA(0).nudMisc.Left + attrCA(0).Left
    End Sub

    Private Function CheckAbortExit() As Boolean
        If hasChanges = True Then
            Dim intAsk As Integer = MsgBox("There may be unsaved changes, are you sure?", MsgBoxStyle.YesNo, "Exit...")
            If intAsk = MsgBoxResult.Yes Then
                Return False
            Else
                Return True
            End If
        Else
            Return False
        End If
    End Function

    Private Sub meResetIH_Click(sender As System.Object, e As System.EventArgs) Handles meResetIH.Click
        ResetAOSTable("tblImplantHelper")
    End Sub

    Private Sub meResetBC_Click(sender As System.Object, e As System.EventArgs) Handles meResetBC.Click
        ResetAOSTable("tblBuffList")
    End Sub

    Private Sub frmMain_VisibleChanged(sender As Object, e As System.EventArgs) Handles Me.VisibleChanged
        initAppNain = False
    End Sub

End Class
